/*
<DEPENDENCIES>
    <DEPENDS>Logger</DEPENDS>
    <DEPENDS>Globals</DEPENDS>
</DEPENDENCIES>
*/
function BrokerActionPipeline()
{
  this.callstack = new Array();
  this.pipeline = new Array();
  this.blockingTasks = new Array();
  this.finalAction = null;
  this.blockCounter = 0;
}
BrokerActionPipeline.prototype.beginAction = function(key)
{
  ;
  this.callstack.push(key);
}
BrokerActionPipeline.prototype.endAction = function(key)
{
  ;
  var closedBrokerKey = this.callstack[this.callstack.length -1];
  if(key != closedBrokerKey)
  {
    ;
  }
  else
  {
    this.callstack.pop();
  }
  this.executePipeline();
}
BrokerActionPipeline.prototype.executePipeline = function()
{
  if((this.callstack.length == 0) && (this.blockCounter == 0))
  {
    this.nextScheduledAction();
  }
}
BrokerActionPipeline.prototype.block = function(key)
{
  ;
  if(!this.blockingTasks[key])
  {
    this.blockingTasks[key] = true;
    this.blockCounter++;
  }
}
BrokerActionPipeline.prototype.unblock = function(key)
{
  ;
  if(this.blockingTasks[key])
  {
    this.blockingTasks[key] = false;
    this.blockCounter--;
  }
  this.executePipeline();
}
BrokerActionPipeline.prototype.scheduleFinalAction = function(action, parameterArray)
{
  ;
  if(this.finalAction)
  {
    ;
  }
  else
  {
    var actionObject = new Object();
    actionObject.action = action;
    actionObject.parameterArray = parameterArray;
    this.finalAction = actionObject;
  }
}
BrokerActionPipeline.prototype.scheduleAction = function(action, parameterArray)
{
  ;
  var actionObject = new Object();
  actionObject.action = action;
  actionObject.parameterArray = parameterArray;
  this.pipeline.push(actionObject);
  this.executePipeline();
}
BrokerActionPipeline.prototype.nextScheduledAction = function()
{
  ;
  if(this.pipeline.length > 0)
  {
    ;
    var actionObject = this.pipeline.shift();
    BrokerActions_callAction(actionObject.action, actionObject.parameterArray);
    this.executePipeline();
  }
  else if(this.finalAction)
  {
    ;
    var callAction = this.finalAction;
    this.finalAction = null;
    BrokerActions_callAction(callAction.action, callAction.parameterArray);
  }
}
function BrokerActions()
{
   this.init()
}
BrokerActions.prototype.init = function(name)
{
  this.actions = new Array();
}
BrokerActions.prototype.callActions = function(parameterArray)
{
  for(id in this.actions)
  {
    var action = this.actions[id];
    BrokerActions_callAction(action, parameterArray);
  }
}
BrokerActions.prototype.addAction = function(action)
{
  this.actions.push(action);
}
function BrokerActions_callAction(action, parameterArray)
{
  if(parameterArray)
  {
    action.invoke(
      parameterArray[0],
      parameterArray[1],
      parameterArray[2],
      parameterArray[3],
      parameterArray[4],
      parameterArray[5],
      parameterArray[6],
      parameterArray[7],
      parameterArray[8]);
  }
  else
  {
    action.invoke();
  }
}
function Broker(name)
{
  this.init(name)
}
Broker.actionPipeline = new BrokerActionPipeline();
Broker.prototype.init = function(name)
{
  this.name = name;
  this.callbacks = new Array();
}
Broker.prototype.getMessage = function(message, parameterArray)
{
  var key = this.name + '_' + message;
  Broker.actionPipeline.beginAction(key);
  var callback = this.callbacks[message];
  if(callback)
  {
    callback.callActions(parameterArray);
  }
  Broker.actionPipeline.endAction(key);
}
Broker.prototype.register = function(match, obj, callback)
{
  ;
}
Broker.prototype.registerAction = function(match, action)
{
  var callback = this.callbacks[match];
  if(!callback)
  {
    callback = new BrokerActions();
    this.callbacks[match] = callback;
  }
  callback.addAction(action);
}
