/*
<DEPENDENCIES>
    <DEPENDS>Browser</DEPENDS>
    <DEPENDS>Logger</DEPENDS>
</DEPENDENCIES>
*/
function AchievementObserver(sId)
{
  if (sId) { this.init(sId); }
}
AchievementObserver.prototype.init = function(sId)
{
  ;
  this.sId = sId;
  this.bAchievmentReached = false;
  this.aReachAchievementActions = new Array();
  this.aReachAchievementWithoutHelpActions = new Array();
}
AchievementObserver.prototype.getId = function()
{
  return this.sId;
}
AchievementObserver.prototype.registerReachAchievementAction = function(reachAchievementAction)
{
  this.aReachAchievementActions.push(reachAchievementAction);
}
AchievementObserver.prototype.registerReachAchievementWithoutHelpAction = function(reachAchievementWithoutHelpAction)
{
  this.aReachAchievementWithoutHelpActions.push(reachAchievementWithoutHelpAction);
}
AchievementObserver.prototype.solved = function(excStatus)
{
  if(!this.bAchievmentReached)
  {
    if ( excStatus.nCorrect == excStatus.nCorrectStatus && excStatus.nCorrectSystem == 0 && excStatus.nWrongSystem == 0 && excStatus.nWrongStatus == 0 )
    {
      this.bAchievmentReached = true;
      this.invokeActions(this.aReachAchievementWithoutHelpActions);
      this.invokeActions(this.aReachAchievementActions);
      this.bAchievmentReached = false;
    }
    else if ( excStatus.nCorrect == excStatus.nCorrectStatus && excStatus.nWrongStatus == 0 )
    {
      this.bAchievmentReached = true;
      this.invokeActions(this.aReachAchievementActions);
      this.bAchievmentReached = false;
    }
  }
}
AchievementObserver.prototype.invokeActions = function(aActions)
{
    if ( aActions.length )
    {
      for ( var i = 0; i < aActions.length; i++)
      {
        aActions[i].invoke();
      }
    }
}
AchievementObserver.prototype.getSolvedAction = function()
{
  return new ObjectMethodAction(this, "solved");
}
