/*
<DEPENDENCIES>
    <DEPENDS>Broker</DEPENDS>
    <DEPENDS>Logger</DEPENDS>
    <DEPENDS>ServerResult</DEPENDS>
</DEPENDENCIES>
*/
function BrowserImpl(sId)
{
	if (sId)
	{
		this.init(sId)
	}
	;
}
BrowserImpl.prototype.init = function(sId)
{
	;
	this.sId = sId;
	this.nSetToplevelCnt = 2007;
	this.nCoverElement = 0;
	this.eventNames = new EventNames();
	this.Node = new NodeTypes();
	this.aEventListeners = new Array();
	this.aUnloadHandles = new Array();
	var me = this;
	this.unloadCallback = function()
	{
		me.unloadHandler();
	}
	window.BrowserOnUnload = this.unloadCallback;
}
BrowserImpl.prototype.getId = function()
{
	;
	return this.sId;
}
BrowserImpl.prototype.getCharacterSet = function()
{
	;
	if (document.charset)
		return document.charset;
	else if (document.characterSet)
		return document.characterSet;
	else
	{
		;
		return undefined;
	}
}
BrowserImpl.prototype.getBodyScrollTop = function()
{
	;
	return document.body.scrollTop;
}
BrowserImpl.prototype.getBodyScrollLeft = function()
{
	;
	return document.body.scrollLeft;
}
BrowserImpl.prototype.unloadCallback = function()
{
	Browser.unloadHandler();
}
BrowserImpl.prototype.unloadHandler = function()
{
	for (var i = 0; i < this.aEventListeners.length; i++)
	{
		this.removeEventListenerFromDomNode(this.aEventListeners[i].domNode,
				this.aEventListeners[i].eventType,
				this.aEventListeners[i].handler
				);
	}
	for (var i = 0; i < this.aUnloadHandles.length; i++)
	{
		this.aUnloadHandles[i].invoke();
	}
}
BrowserImpl.prototype.addUnloadHandle = function(unloadHandle)
{
	this.aUnloadHandles.push(unloadHandle);
}
BrowserImpl.prototype.addEventListener = function(domId, eventType, handler)
{
	;
	var element = this.getElementById(domId);
	this.addEventListenerToDomNode(element, eventType, handler);
}
BrowserImpl.prototype.addEventListenerToDomNode = function(domNode, eventType, handler)
{
	;
	this.aEventListeners.push({ domNode: domNode,
		eventType: eventType,
		handler: handler
	}
			);
	domNode.attachEvent(eventType, handler);
}
BrowserImpl.prototype.addEventListenerToDocument = function(eventType, handler)
{
	;
	this.addEventListenerToDomNode(document, eventType, handler);
}
BrowserImpl.prototype.removeEventListener = function(domId, eventType, handler)
{
	;
	var element = this.getElementById(domId);
	this.removeEventListenerFromDomNode(element, eventType, handler);
}
BrowserImpl.prototype.removeEventListenerFromDomNode = function(domNode, eventType, handler)
{
	;
	domNode.detachEvent(eventType, handler);
}
BrowserImpl.prototype.removeEventListenerFromDocument = function(eventType, handler)
{
	;
	this.removeEventListenerFromDomNode(document, eventType, handler);
}
BrowserImpl.prototype.getElementById = function(domId)
{
	//;
	var elem = document.getElementById(domId);
	if (! elem)
	{
		;
	}
	return elem;
}
BrowserImpl.prototype.changeStyleById = function(domId, styleName, styleValue)
{
	//;
	var elem = this.getElementById(domId);
	if (elem)
	{
		elem.style[styleName] = styleValue;
	}
}
BrowserImpl.prototype.getStyleById = function(domId, styleName)
{
	//;
	var elem = this.getElementById(domId);
	var style = '';
	if (elem)
	{
		style = elem.style[styleName];
	}
	return style;
}
BrowserImpl.prototype.changeStyleClassById = function(domId, styleClass)
{
	var elem = this.getElementById(domId);
	if (elem)
	{
		elem.className = styleClass;
	}
}
BrowserImpl.prototype.getComputedStyleById = function(domId, styleName)
{
	var elem = this.getElementById(domId);
	return this.getComputedStyle(elem, styleName);
}
BrowserImpl.prototype.getComputedStyle = function(node, styleName)
{
	//;
	var style = '';
	if (node)
	{
		style = node.currentStyle[styleName];
	}
	return style;
}
BrowserImpl.prototype.getPixelComputedStyleById = function(domId, styleName)
{
	var elem = this.getElementById(domId);
	return this.getPixelComputedStyle(elem, styleName);
}
BrowserImpl.prototype.getPixelComputedStyle = function(node, styleName)
{
	var style = this.getComputedStyle(node, styleName);
	var iValue = parseInt(style);
	if (isNaN(iValue))
	{
		return 0;
	}
	else
	{
		return iValue;
	}
}
BrowserImpl.prototype.getPixelStyleById = function(domId, styleName)
{
	var elem = this.getElementById(domId);
	return this.getPixelStyle(elem, styleName);
}
BrowserImpl.prototype.getPixelStyle = function(node, styleName)
{
	var style = '';
	if (node)
	{
		style = node.style[styleName];
		var iValue = parseInt(style);
		if (isNaN(iValue))
		{
			return 0;
		}
		else
		{
			return iValue;
		}
	}
	else
	{
		return 0;
	}
}
BrowserImpl.prototype.changePixelStyleById = function(domId, styleName, iValue)
{
	var elem = this.getElementById(domId);
	return this.changePixelStyle(elem, styleName, iValue);
}
BrowserImpl.prototype.changePixelStyle = function(node, styleName, iValue)
{
	if (node)
	{
		node.style[styleName] = parseInt(iValue) + 'px';
	}
}
BrowserImpl.prototype.setImageSourceById = function(domId, srcURL)
{
	//;
	var elem = this.getElementById(domId);
	if (elem)
	{
		elem.src = srcURL;
	}
}
BrowserImpl.prototype.setImageWidthById = function(domId, width)
{
	//;
	var elem = this.getElementById(domId);
	if (elem)
	{
		elem.width = width;
	}
}
BrowserImpl.prototype.eventStopPropagation = function(event)
{
	//;
	event.cancelBubble = true;
}
BrowserImpl.prototype.eventPreventDefault = function(event)
{
	//;
	event.returnValue = false;
}
BrowserImpl.prototype.getKeyCodeFromEvent = function(event)
{
	//;
	return event.keyCode;
}
BrowserImpl.prototype.getOriginalTargetFromEvent = function(event)
{
	//;
	return event.srcElement;
}
BrowserImpl.prototype.getAbsPos = function(domNode, point)
{
	//;
	point.x += domNode.offsetLeft;
	point.y += domNode.offsetTop;
	if (domNode.offsetParent != null)
	{
		if (domNode.offsetParent.tagName != 'BODY')
		{
			this.getAbsPos(domNode.offsetParent, point);
		}
	}
	else if (domNode.tagName == 'MAP') 
	{
		if (domNode.parentNode.tagName != 'BODY')
		{
			point.x = 0;
			point.y = 0;
			this.getAbsPos(domNode.parentNode, point);
		}
	}
}
BrowserImpl.prototype.getAbsPosHtml = function(domNode, point)
{
	//;
	point.x += domNode.offsetLeft;
	point.y += domNode.offsetTop;
	if (domNode.offsetParent != null)
	{
		if (domNode.offsetParent.tagName != 'HTML')
		{
			this.getAbsPosHtml(domNode.offsetParent, point);
		}
	}
	else if (domNode.tagName == 'MAP') 
	{
		if (domNode.parentNode.tagName != 'HTML')
		{
			point.x = 0;
			point.y = 0;
			this.getAbsPosHtml(domNode.parentNode, point);
		}
	}
}
BrowserImpl.prototype.getScrollPos = function(domNode, point)
{
	//;
	point.x += domNode.scrollLeft;
	point.y += domNode.scrollTop;
	//;
	if (domNode.offsetParent != null)
	{
		if (domNode.offsetParent.tagName != 'BODY')
		{
			this.getScrollPos(domNode.offsetParent, point);
		}
	}
	else if (domNode.tagName == 'MAP') 
	{
		if (domNode.parentNode.tagName != 'BODY')
		{
			point.x = 0;
			point.y = 0;
			this.getScrollPos(domNode.parentNode, point);
		}
	}
}
BrowserImpl.prototype.getScreenPos = function(domNode, point)
{
	//;
	point.x += domNode.offsetLeft - domNode.scrollLeft;
	point.y += domNode.offsetTop - domNode.scrollTop;
	if (domNode.offsetParent != null)
	{
		if (domNode.offsetParent.tagName != 'BODY')
		{
			this.getScreenPos(domNode.offsetParent, point);
		}
	}
	else if (domNode.tagName == 'MAP') 
	{
		if (domNode.parentNode.tagName != 'BODY')
		{
			point.x = 0;
			point.y = 0;
			this.getScreenPos(domNode.parentNode, point);
		}
	}
}
BrowserImpl.prototype.getParentLocation = function(domNode, point)
{
	//;
	domNode = domNode.offsetParent;
	if (domNode != null)
	{
		if (domNode.tagName != 'BODY')
		{
			point.x += domNode.offsetLeft + domNode.clientLeft;
			point.y += domNode.offsetTop + domNode.clientTop;
			this.getParentLocation(domNode, point);
		}
	}
}
BrowserImpl.prototype.getLocation = function(domNode, point)
{
	//;
	point.x += domNode.offsetLeft;
	point.y += domNode.offsetTop;
	this.getParentLocation(domNode, point);
}
BrowserImpl.prototype.getChildById = function(domNode, sId)
{
	//;
	var childNode = null;
	for (i in domNode.childNodes)
	{
		if (domNode.childNodes[i].id == sId)
		{
			childNode = domNode.childNodes[i];
			break;
		}
	}
	return childNode;
}
BrowserImpl.prototype.moveTo = function(domNode, point)
{
	//;
	domNode.style.position = 'absolute';
	var parentPos = new Point(0, 0);
	if (domNode.offsetParent)
	{
		this.getAbsPos(domNode.offsetParent, parentPos);
	}
	domNode.style.left = (point.x - parentPos.x) + 'px';
	domNode.style.top = (point.y - parentPos.y) + 'px';
}
BrowserImpl.prototype.moveToLocation = function(domNode, point)
{
	//;
	domNode.style.position = 'absolute';
	var parentPos = new Point(0, 0);
	this.getLocation(domNode, parentPos);
	domNode.style.left = (point.x - parentPos.x) + 'px';
	domNode.style.top = (point.y - parentPos.y) + 'px';
}
BrowserImpl.prototype.setToplevel = function(domNode)
{
	;
	
	
	this.nSetToplevelCnt += 10;
	domNode.style.zIndex = this.nSetToplevelCnt;
}
BrowserImpl.prototype.loadDocument = function(url, onLoadAction, onErrorAction)
{
	var xmldoc = new ActiveXObject("Microsoft.XMLDOM");
	xmldoc.onreadystatechange = function()
	{
		if (xmldoc.readyState == 4)
		{
			if (xmldoc.parseError.errorCode != 0)
			{
				if (onErrorAction)
				{
					onErrorAction.invoke();
				}
				Broker.actionPipeline.unblock(url);
			}
			else
			{
				if (onLoadAction)
				{
					onLoadAction.invoke(xmldoc);
				}
				Broker.actionPipeline.unblock(url);
			}
		}
	}
	Broker.actionPipeline.block(url);
	xmldoc.load(url);
}
BrowserImpl.prototype.loadXMLDocument = function(url, onLoadAction, onErrorAction)
{
	var request = null;
	try
	{
		request = new ActiveXObject("Msxml2.XMLHTTP");
	}
	catch(e)
	{
		try
		{
			request = new ActiveXObject("Microsoft.XMLHTTP");
		}
		catch(e)
		{
			request = null;
		}
	}
	if (request == null)
	{
		if (onErrorAction)
			onErrorAction.invoke("Could not instantiate XMLHttpRequest !");
	}
	else
	{
		var onloadHandler = function()
		{
			if (request.readyState == 4)
			{
				if (request.status == 200)
				{
					if (onLoadAction)
						onLoadAction.invoke(request.responseXML);
				}
				else
				{
					alert(request.statusText);
					if (onErrorAction)
						onErrorAction.invoke("Errors retrieveing XML for url " + url + ". Message is: " + request.statusText);
				}
				Broker.actionPipeline.unblock(url);
			}
		};
		Broker.actionPipeline.block(url);
		request.onreadystatechange = onloadHandler;
		request.open("GET", url, true);
		request.send("");
	}
}
BrowserImpl.prototype.loadXMLDocumentPost = function(url, args, onLoadAction, onErrorAction)
{
	var request = null;
	try
	{
		request = new ActiveXObject("Msxml2.XMLHTTP");
	}
	catch(e)
	{
		try
		{
			request = new ActiveXObject("Microsoft.XMLHTTP");
		}
		catch(e)
		{
			request = null;
		}
	}
	if (request == null)
	{
		if (onErrorAction)
			onErrorAction.invoke("Could not instantiate XMLHttpRequest !");
	}
	else
	{
		var onloadHandler = function()
		{
			if (request.readyState == 4)
			{
				if (request.status == 200)
				{
					if (onLoadAction)
						onLoadAction.invoke(request.responseXML);
				}
				else
				{
					alert(request.statusText);
					if (onErrorAction)
						onErrorAction.invoke("Errors retrieveing XML for url " + url + ". Message is: " + request.statusText);
				}
				Broker.actionPipeline.unblock(url);
			}
		};
		Broker.actionPipeline.block(url);
		request.onreadystatechange = onloadHandler;
		request.open("POST", url, true);
		request.setRequestHeader('Content-Type', 'application/x-www-form-urlencoded');
		request.send(args);
	}
}
BrowserImpl.prototype.callURL = function(url, onLoadAction, onErrorAction)
{
	var xmldoc = new ActiveXObject("Microsoft.XMLDOM");
	xmldoc.onreadystatechange = function()
	{
		if (xmldoc.readyState == 4)
		{
			if (xmldoc.parseError.errorCode != 0)
			{
				if (onErrorAction)
				{
					onErrorAction.invoke();
				}
				Broker.actionPipeline.unblock(url);
			}
			else
			{
				if (onLoadAction)
				{
					onLoadAction.invoke();
				}
				Broker.actionPipeline.unblock(url);
			}
		}
	}
	Broker.actionPipeline.block(url);
	xmldoc.load(url);
}
BrowserImpl.prototype.callServer = function(url, onLoadAction, onErrorAction)
{
	var xmldoc = new ActiveXObject("Microsoft.XMLDOM");
	xmldoc.onreadystatechange = function()
	{
		if (xmldoc.readyState == 4)
		{
			if (xmldoc.parseError.errorCode != 0)
			{
				if (onErrorAction)
				{
					onErrorAction.invoke();
				}
				Broker.actionPipeline.unblock(url);
			}
			else
			{
				if (onLoadAction)
				{
					var result = new ServerResult(this.sId + '_result', xmldoc);
					onLoadAction.invoke(result.getValues());
				}
				Broker.actionPipeline.unblock(url);
			}
		}
	}
	Broker.actionPipeline.block(url);
	xmldoc.load(url);
}
BrowserImpl.prototype.getCoverElement = function(elem)
{
	this.nCoverElement++;
	var oCoverElem = document.createElement("IMG");
	oCoverElem.id = 'Browser_sCoverWidgetDomId_' + this.nCoverElement;
	oCoverElem.src = '../af-web/js/img/trans.png';
	if (elem && elem.style)
	{
		var zindex = this.getComputedStyle(elem, 'zIndex');
		if (zindex == 'auto')
		{
			this.setToplevel(oCoverElem);
		}
		else
		{
			oCoverElem.style.zIndex = parseInt(zindex) + 1;
		}
	}
	return oCoverElem;
}
BrowserImpl.prototype.replaceRelative = function(url)
{
	document.location.href = this.getRelativeURL(url);
}
BrowserImpl.prototype.getRelativeURL = function(url)
{
	var relURL;
	var oBaseArray = document.all.tags('BASE');
	var oBase = (oBaseArray && oBaseArray.length) ? oBaseArray[0].href : null;
	if (oBase)
	{
		if (oBase.lastIndexOf('/') == (oBase.length - 1))
		{
			relURL = oBase + url;
		}
		else
		{
			relURL = oBase + '/' + url;
		}
	}
	else
		relURL = url;
	return relURL;
}
BrowserImpl.prototype.getBaseURL = function()
{
	var oBaseArray = document.all.tags('BASE');
	return (oBaseArray && oBaseArray.length) ? oBaseArray[0].href : '';
}
BrowserImpl.prototype.getEventSourceElement = function(event)
{
	return event.srcElement;
}
BrowserImpl.prototype.removeNodeFromParent = function(node)
{
	if (this.orphanageNode == null)
	{
		var bodyNodes = document.getElementsByTagName('body');
		if (bodyNodes.length > 0)
		{
			var bodyNode = bodyNodes[0];
			this.orphanageNode = document.createElement('div');
			this.orphanageNode.id = 'node_orphanage_' + new Date().getTime();
			this.orphanageNode.style.display = 'none';
			bodyNode.appendChild(this.orphanageNode);
		}
	}
	if (this.orphanageNode != null)
	{
		this.orphanageNode.appendChild(node);
	}
}
function EventNames()
{
	this.LOAD = 'onload';
	this.CLICK = 'onclick';
	this.DOUBLECLICK = 'ondblclick';
	this.DRAGDROP = 'ondragdrop';
	this.CHANGE = 'onchange';
	this.MOUSEDOWN = 'onmousedown';
	this.MOUSEUP = 'onmouseup';
	this.MOUSEOVER = 'onmouseover';
	this.MOUSEOUT = 'onmouseout';
	this.MOUSEMOVE = 'onmousemove';
	this.SELECT = 'onselect';
	this.BLUR = 'onblur';
	this.FOCUS = 'onfocus';
	this.KEYPRESS = 'onkeypress';
	this.KEYUP = 'onkeyup';
	this.KEYDOWN = 'onkeydown';
	this.DRAGSTART = 'ondragstart';
	this.SELECTIONCHANGE = 'onselectionchange';
	this.BEFOREPASTE = 'onbeforepaste';
	this.SELECTSTART = 'onselectstart';
	this.MOUSEWHEEL = 'onmousewheel';
}
function NodeTypes()
{
	this.ELEMENT_NODE = 1;
	this.ATTRIBUTE_NODE = 2;
	this.TEXT_NODE = 3;
	this.CDATA_SECTION_NODE = 4;
	this.ENTITY_REFERENCE_NODE = 5;
	this.ENTITY_NODE = 6;
	this.PROCESSING_INSTRUCTION_NODE = 7;
	this.COMMENT_NODE = 8;
	this.DOCUMENT_NODE = 9;
	this.DOCUMENT_TYPE_NODE = 10;
	this.DOCUMENT_FRAGMENT_NODE = 11;
	this.NOTATION_NODE = 12;
}
Browser = new BrowserImpl('ie');
