/*
<DEPENDENCIES>
    <DEPENDS>Broker</DEPENDS>
    <DEPENDS>Logger</DEPENDS>
    <DEPENDS>ServerResult</DEPENDS>
</DEPENDENCIES>
*/
function BrowserImpl(sId)
{
	if (sId)
	{
		this.init(sId)
	}
	;
}
BrowserImpl.prototype.init = function(sId)
{
	;
	this.sId = sId;
	this.nSetToplevelCnt = 2007;
	this.eventNames = new EventNames();
	this.Node = new NodeTypes();
	this.aEventListeners = new Array();
	this.nCoverElement = 0;
	this.aUnloadHandles = new Array();
	this.orphanageNode = null;
	this.loadingImages = new Array();
	var me = this;
	this.unloadCallback = function()
	{
		me.unloadHandler();
	}
	window.BrowserOnUnload = this.unloadCallback;
}
BrowserImpl.prototype.getId = function()
{
	;
	return this.sId;
}
BrowserImpl.prototype.getCharacterSet = function()
{
	;
	if (document.characterSet)
		return document.characterSet;
	else if (document.charset)
		return document.charset;
	else
	{
		;
		return undefined;
	}
}
BrowserImpl.prototype.getBodyScrollTop = function()
{
	;
	return document.body.scrollTop;
}
BrowserImpl.prototype.getBodyScrollLeft = function()
{
	;
	return document.body.scrollLeft;
}
BrowserImpl.prototype.unloadHandler = function()
{
	for (var i = 0; i < this.aEventListeners.length; i++)
	{
		this.aEventListeners[i].domNode.removeEventListener(
				this.aEventListeners[i].eventType,
				this.aEventListeners[i].handler,
				true
				);
	}
	for (var i = 0; i < this.aUnloadHandles.length; i++)
	{
		this.aUnloadHandles[i].invoke();
	}
}
BrowserImpl.prototype.addUnloadHandle = function(unloadHandle)
{
	this.aUnloadHandles.push(unloadHandle);
}
BrowserImpl.prototype.unloadCallback = function()
{
	Browser.unloadHandler();
}
BrowserImpl.prototype.addEventListener = function(domId, eventType, handler)
{
	;
	var element = this.getElementById(domId);
	this.addEventListenerToDomNode(element, eventType, handler);
}
BrowserImpl.prototype.addEventListenerToDomNode = function(domNode, eventType, handler)
{
	;
	this.aEventListeners.push({ domNode: domNode,
		eventType: eventType,
		handler: handler
	}
			);
	domNode.addEventListener(eventType, handler, true);
}
BrowserImpl.prototype.addEventListenerToDocument = function(eventType, handler)
{
	;
	this.addEventListenerToDomNode(document, eventType, handler);
}
BrowserImpl.prototype.removeEventListener = function(domId, eventType, handler)
{
	;
	var element = this.getElementById(domId);
	this.removeEventListenerFromDomNode(element, eventType, handler);
}
BrowserImpl.prototype.removeEventListenerFromDomNode = function(domNode, eventType, handler)
{
	;
	domNode.removeEventListener(eventType, handler, true);
}
BrowserImpl.prototype.removeEventListenerFromDocument = function(eventType, handler)
{
	;
	this.removeEventListenerFromDomNode(document, eventType, handler);
}
BrowserImpl.prototype.getElementById = function(domId)
{
	//;
	var elem = document.getElementById(domId);
	if (! elem)
	{
		;
	}
	return elem;
}
BrowserImpl.prototype.changeStyleById = function(domId, styleName, styleValue)
{
	//;
	var elem = this.getElementById(domId);
	if (elem)
	{
		elem.style[styleName] = styleValue;
	}
}
BrowserImpl.prototype.changeStyleClassById = function(domId, styleClass)
{
	var elem = this.getElementById(domId);
	if (elem)
	{
		elem.className = styleClass;
	}
}
BrowserImpl.prototype.getStyleById = function(domId, styleName)
{
	//;
	var elem = this.getElementById(domId);
	var style = '';
	if (elem)
	{
		style = elem.style[styleName];
	}
	return style;
}
BrowserImpl.prototype.getComputedStyleById = function(domId, styleName)
{
	var elem = this.getElementById(domId);
	return this.getComputedStyle(elem, styleName);
}
BrowserImpl.prototype.getComputedStyle = function(node, styleName)
{
	//;
	var style = '';
	if (node)
	{
		style = window.getComputedStyle(node, null)[styleName];
	}
	return style;
}
BrowserImpl.prototype.getPixelComputedStyleById = function(domId, styleName)
{
	var elem = this.getElementById(domId);
	return this.getPixelComputedStyle(elem, styleName);
}
BrowserImpl.prototype.getPixelComputedStyle = function(node, styleName)
{
	var style = this.getComputedStyle(node, styleName);
	var iValue = parseInt(style);
	if (isNaN(iValue))
	{
		return 0;
	}
	else
	{
		return iValue;
	}
}
BrowserImpl.prototype.getPixelStyleById = function(domId, styleName)
{
	var elem = this.getElementById(domId);
	return this.getPixelStyle(elem, styleName);
}
BrowserImpl.prototype.getPixelStyle = function(node, styleName)
{
	var style = '';
	if (node)
	{
		style = node.style[styleName];
		var iValue = parseInt(style);
		if (isNaN(iValue))
		{
			return 0;
		}
		else
		{
			return iValue;
		}
	}
	else
	{
		return 0;
	}
}
BrowserImpl.prototype.changePixelStyleById = function(domId, styleName, iValue)
{
	var elem = this.getElementById(domId);
	return this.changePixelStyle(elem, styleName, iValue);
}
BrowserImpl.prototype.changePixelStyle = function(node, styleName, iValue)
{
	if (node)
	{
		node.style[styleName] = parseInt(iValue) + 'px';
	}
}
BrowserImpl.prototype.setImageSourceById = function(domId, srcURL)
{
	var elem = this.getElementById(domId);
	if (elem)
	{
		if (elem.complete != true && elem.src != "")
		{
			this.loadingImages[domId] = srcURL;
			window.setTimeout('Browser.checkLoadingImages()', 300);
		}
		else
		{
			elem.src = srcURL;
		}
	}
}
BrowserImpl.prototype.checkLoadingImages = function()
{
	var c = 0;
	for (domId in this.loadingImages)
	{
		var elem = this.getElementById(domId);
		if (elem)
		{
			if (elem.complete == false && elem.src != "")
			{
				c++;
			}
			else
			{
				elem.src = this.loadingImages[domId];
			}
		}
	}
	if (c > 0)
	{
		window.setTimeout('Browser.checkLoadingImages()', 300);
	}
}
BrowserImpl.prototype.setImageWidthById = function(domId, width)
{
	//;
	var elem = this.getElementById(domId);
	if (elem)
	{
		elem.width = width;
	}
}
BrowserImpl.prototype.eventStopPropagation = function(event)
{
	event.stopPropagation();
}
BrowserImpl.prototype.eventPreventDefault = function(event)
{
	event.preventDefault();
}
BrowserImpl.prototype.getKeyCodeFromEvent = function(event)
{
	//;
	return event.which;
}
BrowserImpl.prototype.getOriginalTargetFromEvent = function(event)
{
	//;
	return event.originalTarget;
}
BrowserImpl.prototype.getAbsPos = function(domNode, point)
{
	//;
	point.x += domNode.offsetLeft;
	point.y += domNode.offsetTop;
	if (domNode.offsetParent != null)
	{
		if (domNode.offsetParent.tagName != 'BODY')
		{
			this.getAbsPos(domNode.offsetParent, point);
		}
	}
}
BrowserImpl.prototype.getAbsPosHtml = function(domNode, point)
{
	//;
	point.x += domNode.offsetLeft;
	point.y += domNode.offsetTop;
	if (domNode.offsetParent != null)
	{
		if (domNode.offsetParent.tagName != 'HTML')
		{
			this.getAbsPosHtml(domNode.offsetParent, point);
		}
	}
}
BrowserImpl.prototype.getScrollPos = function(domNode, point)
{
	//;
	point.x += domNode.scrollLeft;
	point.y += domNode.scrollTop;
	//;
	if (domNode.offsetParent != null)
	{
		if (domNode.nodeName != 'HTML')
		{
			this.getScrollPos(domNode.offsetParent, point);
		}
	}
	else
	{
		point.x += pageXOffset;
		point.y += pageYOffset;
	}
}
BrowserImpl.prototype.getScreenPos = function(domNode, point)
{
	//;
	point.x += domNode.offsetLeft - domNode.scrollLeft;
	point.y += domNode.offsetTop - domNode.scrollTop;
	if (domNode.offsetParent != null)
	{
		if (domNode.offsetParent.tagName != 'BODY')
		{
			this.getScreenPos(domNode.offsetParent, point);
		}
	}
}
BrowserImpl.prototype.getParentLocation = function(domNode, point)
{
	//;
	domNode = domNode.offsetParent;
	if (domNode != null)
	{
		if (domNode.tagName != 'BODY')
		{
			point.x += domNode.offsetLeft + this.getPixelComputedStyle(domNode, "borderLeftWidth");
			point.y += domNode.offsetTop + this.getPixelComputedStyle(domNode, "borderTopWidth");
			this.getParentLocation(domNode, point);
		}
	}
}
BrowserImpl.prototype.getLocation = function(domNode, point)
{
	//;
	point.x += domNode.offsetLeft;
	point.y += domNode.offsetTop;
	this.getParentLocation(domNode, point);
}
BrowserImpl.prototype.getChildById = function(domNode, sId)
{
	//;
	var childNode = null;
	for (i in domNode.childNodes)
	{
		if (domNode.childNodes[i].id == sId)
		{
			childNode = domNode.childNodes[i];
			break;
		}
	}
	return childNode;
}
BrowserImpl.prototype.moveTo = function(domNode, point)
{
	//;
	domNode.style.position = 'absolute';
	var parentPos = new Point(0, 0);
	if (domNode.offsetParent)
	{
		this.getAbsPos(domNode.offsetParent, parentPos);
	}
	domNode.style.left = (point.x - parentPos.x) + 'px';
	domNode.style.top = (point.y - parentPos.y) + 'px';
}
BrowserImpl.prototype.moveToLocation = function(domNode, point)
{
	//;
	domNode.style.position = 'absolute';
	var parentPos = new Point(0, 0);
	this.getLocation(domNode, parentPos);
	domNode.style.left = (point.x - parentPos.x) + 'px';
	domNode.style.top = (point.y - parentPos.y) + 'px';
}
BrowserImpl.prototype.getKeyCodeFromEvent = function(event)
{
	//;
	return event.which;
}
BrowserImpl.prototype.setToplevel = function(domNode)
{
	;
	
	
	this.nSetToplevelCnt += 10;
	domNode.style.zIndex = this.nSetToplevelCnt;
}
BrowserImpl.prototype.loadDocument = function(url, onLoadAction, onErrorAction)
{
	var xmldoc = document.implementation.createDocument("", "", null);
	var onloadHandler = function()
	{
		if (onLoadAction)
			onLoadAction.invoke(xmldoc);
		Broker.actionPipeline.unblock(url);
	};
	var onabortHandler = function()
	{
		if (onErrorAction)
			onErrorAction.invoke();
		Broker.actionPipeline.unblock(url);
	};
	var onerrorHandler = function()
	{
		if (onErrorAction)
			onErrorAction.invoke();
		Broker.actionPipeline.unblock(url);
	};
	xmldoc.addEventListener("load", onloadHandler, true);
	xmldoc.addEventListener("error", onerrorHandler, true);
	xmldoc.addEventListener("abort", onabortHandler, true);
	Broker.actionPipeline.block(url);
	xmldoc.load(url);
}
BrowserImpl.prototype.loadXMLDocument = function(url, onLoadAction, onErrorAction)
{
	var request = new XMLHttpRequest();
	var onloadHandler = function()
	{
		if (request.readyState == 4)
		{
			if (request.status == 200)
			{
				if (onLoadAction)
					onLoadAction.invoke(request.responseXML);
			}
			else
			{
				if (onErrorAction)
					onErrorAction.invoke("Errors retrieveing XML for url " + url + ". Message is: " + request.statusText);
			}
			Broker.actionPipeline.unblock(url);
		}
	};
	Broker.actionPipeline.block(url);
	request.onreadystatechange = onloadHandler;
	request.open("GET", url, true);
	request.send("");
}
BrowserImpl.prototype.callURL = function(url, onLoadAction, onErrorAction)
{
	var xmldoc = document.implementation.createDocument("", "", null);
	var onloadHandler = function()
	{
		if (onLoadAction)
			onLoadAction.invoke();
		Broker.actionPipeline.unblock(url);
	};
	var onabortHandler = function()
	{
		if (onErrorAction)
			onErrorAction.invoke();
		Broker.actionPipeline.unblock(url);
	};
	var onerrorHandler = function()
	{
		if (onErrorAction)
			onErrorAction.invoke();
		Broker.actionPipeline.unblock(url);
	};
	xmldoc.addEventListener("load", onloadHandler, true);
	xmldoc.addEventListener("error", onerrorHandler, true);
	xmldoc.addEventListener("abort", onabortHandler, true);
	Broker.actionPipeline.block(url);
	xmldoc.load(url);
}
BrowserImpl.prototype.callServer = function(url, onLoadAction, onErrorAction)
{
	var xmldoc = document.implementation.createDocument("", "", null);
	var onloadHandler = function()
	{
		if (onLoadAction)
		{
			var result = new ServerResult(this.sId + '_result', xmldoc);
			onLoadAction.invoke(result.getValues());
		}
		Broker.actionPipeline.unblock(url);
	};
	var onabortHandler = function()
	{
		if (onErrorAction)
			onErrorAction.invoke();
		Broker.actionPipeline.unblock(url);
	};
	var onerrorHandler = function()
	{
		if (onErrorAction)
			onErrorAction.invoke();
		Broker.actionPipeline.unblock(url);
	};
	xmldoc.addEventListener("load", onloadHandler, true);
	xmldoc.addEventListener("error", onerrorHandler, true);
	xmldoc.addEventListener("abort", onabortHandler, true);
	Broker.actionPipeline.block(url);
	xmldoc.load(url);
}
BrowserImpl.prototype.getCoverElement = function(elem)
{
	this.nCoverElement++;
	var oCoverElem = document.createElement("DIV");
	oCoverElem.id = 'Browser_sCoverWidgetDomId_' + this.nCoverElement;
	if (elem && elem.style)
	{
		var zindex = this.getComputedStyle(elem, 'zIndex');
		if (zindex == 'auto')
		{
			this.setToplevel(oCoverElem);
		}
		else
		{
			oCoverElem.style.zIndex = parseInt(zindex) + 1;
		}
	}
	return oCoverElem;
}
BrowserImpl.prototype.replaceRelative = function(url)
{
	document.location.href = url;
}
BrowserImpl.prototype.replaceRelative = function(url)
{
	document.location.href = this.getRelativeURL(url);
}
BrowserImpl.prototype.getRelativeURL = function(url)
{
	return url;
}
BrowserImpl.prototype.getBaseURL = function()
{
	return window.document.baseURI;
}
BrowserImpl.prototype.getEventSourceElement = function(event)
{
	return event.explicitOriginalTarget;
}
BrowserImpl.prototype.removeNodeFromParent = function(node)
{
	if (this.orphanageNode == null)
	{
		var bodyNodes = document.getElementsByTagName('body');
		if (bodyNodes.length > 0)
		{
			var bodyNode = bodyNodes[0];
			this.orphanageNode = document.createElement('div');
			this.orphanageNode.id = 'node_orphanage_' + new Date().getTime();
			this.orphanageNode.style.display = 'none';
			bodyNode.appendChild(this.orphanageNode);
		}
	}
	if (this.orphanageNode != null)
	{
		this.orphanageNode.appendChild(node);
	}
}
function EventNames()
{
   	this.LOAD = 'load';
	this.UNLOAD = 'unload';
	this.CLICK = 'click';
	this.DOUBLECLICK = 'dblclick';
	this.DRAGDROP = 'dragdrop';
	this.CHANGE = 'change';
	this.MOUSEDOWN = 'mousedown';
	this.MOUSEUP = 'mouseup';
	this.MOUSEOVER = 'mouseover';
	this.MOUSEOUT = 'mouseout';
	this.MOUSEMOVE = 'mousemove';
	this.SELECT = 'select';
	this.BLUR = 'blur';
	this.FOCUS = 'focus';
	this.KEYPRESS = 'keypress';
	this.KEYUP = 'keyup';
	this.KEYDOWN = 'keydown';
	this.DRAGSTART = '';
	this.MOUSEWHEEL = 'DOMMouseScroll';
}
function NodeTypes()
{
	this.ELEMENT_NODE = Node.ELEMENT_NODE;
	this.ATTRIBUTE_NODE = Node.ATTRIBUTE_NODE;
	this.TEXT_NODE = Node.TEXT_NODE;
	this.CDATA_SECTION_NODE = Node.CDATA_SECTION_NODE;
	this.ENTITY_REFERENCE_NODE = Node.ENTITY_REFERENCE_NODE;
	this.ENTITY_NODE = Node.ENTITY_NODE;
	this.PROCESSING_INSTRUCTION_NODE = Node.PROCESSING_INSTRUCTION_NODE;
	this.COMMENT_NODE = Node.COMMENT_NODE;
	this.DOCUMENT_NODE = Node.DOCUMENT_NODE;
	this.DOCUMENT_TYPE_NODE = Node.DOCUMENT_TYPE_NODE;
	this.DOCUMENT_FRAGMENT_NODE = Node.DOCUMENT_FRAGMENT_NODE;
	this.NOTATION_NODE = Node.NOTATION_NODE;
}
Browser = new BrowserImpl('safari');
