/*
<DEPENDENCIES>
    <DEPENDS>Logger</DEPENDS>
    <DEPENDS>Browser</DEPENDS>
    <DEPENDS>Attribute</DEPENDS>
</DEPENDENCIES>
*/
function ElementIdentifier(sId)
{
	this.init(sId);
}
ElementIdentifier.prototype.init = function(sId)
{
	this.sId = sId;
	this.element = null;
	this.level = 0;
}
ElementIdentifier.prototype.getId = function()
{
	return this.sId;
}
ElementIdentifier.prototype.resolve = function(pageDocument)
{
	
}
ElementIdentifier.prototype.getLevel = function()
{
	return this.level;
}
ElementIdentifier.prototype.exists = function()
{
	return (this.element != null);
}
ElementIdentifier.prototype.getPosition = function()
{
	var pos = new Point(0, 0);
	if (this.exists())
		Browser.getAbsPosHtml(this.element, pos);
	return pos;
}
ElementIdentifier.prototype.getElement = function()
{
	return this.element;
}
ElementIdentifier.prototype.getWidth = function()
{
	if (this.exists())
		return this.element.scrollWidth;
	return 0;
}
ElementIdentifier.prototype.getHeight = function()
{
	if (this.exists())
		return this.element.scrollHeight;
	return 0;
}
ElementIdentifier.prototype.initLevel = function()
{
	if (this.element != null)
	{
		var parent = this.element.parentNode;
		while (parent != null && parent.tagName != "BODY")
		{
			this.level = this.level + 1;
			parent = parent.parentNode;
		}
	}
}
ElementIdentifierByTag.prototype = new ElementIdentifier();
ElementIdentifierByTag.prototype.constructor = ElementIdentifierByTag;
ElementIdentifierByTag.superclass = ElementIdentifier.prototype;
function ElementIdentifierByTag(sId, tagName, attributes, index)
{
	this.init(sId, tagName, attributes, index);
}
ElementIdentifierByTag.prototype.init = function(sId, tagName, attributes, index)
{
	ElementIdentifierByTag.superclass.init.call(this, sId);
	this.tagName = tagName;
	this.attributes = new Array();
	for (var i = 0; i < attributes.length; i ++)
	{
		var attr = attributes[i];
		this.attributes[attr.getKey()] = attr.getValue();
	}
	this.numberOfAttributes = attributes.length;
	this.index = index;
}
ElementIdentifierByTag.prototype.resolve = function(pageDocument)
{
	if (pageDocument)
	{
		var elements = pageDocument.getElementsByTagName(this.tagName);
		this.element = null;
		if (elements.length == 0)
			return;
		if (elements.length == 1)
		{
			
			this.element = elements[0];
		}
		else
		{
			
			
			var attributMatches = new Array();
			for (var i = 0; i < elements.length; i++)
			{
				var checkElement = elements[i];
				var matches = false;
				for (var key in this.attributes)
				{
					if (checkElement.getAttribute(key) == this.attributes[key])
					{
						
						matches = true;
					}
					else if (key == 'class' && checkElement.className == this.attributes[key])
					{
						
						matches = true;
					}
					else
					{
						
						matches = false;
						break;
					}
				}
				if (matches == true)
					attributMatches.push(checkElement);
			}
			
			if (this.numberOfAttributes == 0)
			{
				if (this.index < elements.length)
				{
					this.element = elements[this.index];
				}
			}
			else if (attributMatches.length == 1)
			{
				
				this.element = attributMatches[0];
			}
			else if (attributMatches.length > 1)
			{
				
				
				if (this.index < attributMatches.length)
				{
					this.element = attributMatches[this.index];
				}
			}
		}
		if (this.element != null && this.element.nodeName == "A"
				&& this.element.hasChildNodes() && this.element.firstChild.nodeName != "#text")
		{
			
			this.element = this.element.firstChild;
		}
		this.initLevel();
	}
}
ElementIdentifierById.prototype = new ElementIdentifier();
ElementIdentifierById.prototype.constructor = ElementIdentifierById;
ElementIdentifierById.superclass = ElementIdentifier.prototype;
function ElementIdentifierById(sId, domid)
{
	this.init(sId, domid);
}
ElementIdentifierById.prototype.init = function(sId, domid)
{
	ElementIdentifierById.superclass.init.call(this, sId);
	this.domid = domid;
}
ElementIdentifierById.prototype.resolve = function(pageDocument)
{
	if (pageDocument)
		this.element = pageDocument.getElementById(this.domid);
	this.initLevel();
}
