/*
<DEPENDENCIES>
    <DEPENDS>Browser</DEPENDS>
    <DEPENDS>Logger</DEPENDS>
</DEPENDENCIES>
*/
function HangmanKeyAdapter(sId)
{
  if (sId) { this.init(sId); }
}
HangmanKeyAdapter.prototype.init = function(sId)
{
  ;   
  this.sId = sId;
  this.oHangmanManager = null;
  this.modelItem = null;
}
HangmanKeyAdapter.prototype.getId = function()
{
  return this.sId;
}
HangmanKeyAdapter.prototype.setModelItem = function(modelItem)
{
  ;
  this.modelItem = modelItem;
}
HangmanKeyAdapter.prototype.getModelItem = function()
{
  return this.modelItem;
}
HangmanKeyAdapter.prototype.setManager = function(oHangmanManager)
{
  //;     
  if(oHangmanManager)
  {
    this.oHangmanManager = oHangmanManager;
  }
}
HangmanKeyAdapter.prototype.changed = function(model)
{
  ;
  if (model.isEvaluated())
  {
    if (model.isSolved() == true)
    {
      if (this.broker) { this.broker.showCorrect(); }
    }
    else if (model.isSolved() == false)
    {
      if (this.broker) { this.broker.showWrong(); }
    }
    else
    {
    }
  }
  else
  {
    var sText = model.getText();
    var nCount = model.countActiveEvaluations();
    if (nCount == 0)
    {
      if (this.oHangmanManager) { this.oHangmanManager.enableKeyWidgetByText(sText, true); }
    }
    else
    {
      if (this.oHangmanManager) { this.oHangmanManager.enableKeyWidgetByText(sText, false); }
    }
  }
}
function HangmanQuestionWidget(sId, sHangmanQuestionWidgetDomId)
{
  if (sId) { this.init(sId, sHangmanQuestionWidgetDomId); }
}
HangmanQuestionWidget.prototype.init = function(sId, sHangmanQuestionWidgetDomId)
{
  ;   
  this.sId = sId;
  this.modelItem = null;
  this.oHangmanManager = null;
  this.correctColor = null;
  this.wrongColor = null;
  this.tipColor = null;
  this.inactiveColor = null;
  this.bIsTip = false;
  this.hangmanQuestionWidget = document.getElementById(sHangmanQuestionWidgetDomId);
  this.sHangmanQuestionWidgetDomId = sHangmanQuestionWidgetDomId;
  if (this.hangmanQuestionWidget == null)
  {
      ;
  }
}
HangmanQuestionWidget.prototype.getId = function()
{
  return this.sId;
}
HangmanQuestionWidget.prototype.setModelItem = function(modelItem)
{
  ;
  this.modelItem = modelItem;
}
HangmanQuestionWidget.prototype.getModelItem = function()
{
  return this.modelItem;
}
HangmanQuestionWidget.prototype.setManager = function(oHangmanManager)
{
  //;     
  if(oHangmanManager)
  {
    this.oHangmanManager = oHangmanManager;
  }
}
HangmanQuestionWidget.prototype.changed = function(model)
{
  ;
  if (model.isEvaluated())
  {
    if (model.isSolved() == true || ( model && model.workItem.getEvaluation( model, model.getSolutionComplement()).isActive() ) )
    {
      if ( ! this.bIsTip )
      {
        this.hangmanQuestionWidget.innerHTML = model.getActiveComplement().getText();
        this.hangmanQuestionWidget.style.color = this.correctColor;
        if (this.broker) { this.broker.showCorrect(); }
      }
      else
      {
        this.hangmanQuestionWidget.innerHTML = model.getActiveComplement().getText();
        this.hangmanQuestionWidget.style.color = this.tipColor;
      }
    }
    else if (model.isSolved() == false)
    {
      this.hangmanQuestionWidget.innerHTML = model.getSolutionComplement().getText();
      this.hangmanQuestionWidget.style.color = this.wrongColor;
      if (this.broker) { this.broker.showWrong(); }
    }
    else
    {
    }
  }
  else
  {
    var nCount = model.countActiveEvaluations();
    if (nCount == 0)
    {
      switch (model.getEvaluation().getOrigin())
      {
        case 'system_solution':
          break;
        default:
          this.hangmanQuestionWidget.innerHTML = '';
          this.hangmanQuestionWidget.style.color = this.inactiveColor;
          if (this.broker) { this.broker.showUnassigned(); }
       }
    }
    else
    {
      switch (model.getEvaluation().getOrigin())
      {
        case 'user':
          this.hangmanQuestionWidget.style.color = this.inactiveColor;
          if (model.getEvaluation().isCorrect())
          {
            this.hangmanQuestionWidget.innerHTML = model.getActiveComplement().getText();
            if (this.broker) { this.broker.showCorrect(); }
          }
          else 
          {
            if(model.getEvaluation().isActive())
            {
              this.oHangmanManager.wrongChangeInHangmanQuestionWidget(model.getEvaluation().getAnswer().getText());
            }
          }
          break;
        case 'system_solution':
          if (model.getEvaluation().isCorrect())
          {
            this.hangmanQuestionWidget.innerHTML = model.getActiveComplement().getText();
            this.hangmanQuestionWidget.style.color = this.tipColor;
            this.bIsTip = true;
            if (this.broker) { this.broker.showSolution(); }
          }
          break;
        case 'system_set':
          if (model.getEvaluation().isCorrect())
          {
            this.hangmanQuestionWidget.innerHTML = model.getActiveComplement().getText();
            this.hangmanQuestionWidget.style.color = this.tipColor;
            this.bIsTip = true;
            if (this.broker) { this.broker.showTipAssigned(); }
          }
          break;
        case 'system_approve':
          if (model.getEvaluation().isCorrect())
          {
            this.hangmanQuestionWidget.innerHTML = model.getActiveComplement().getText();
            this.hangmanQuestionWidget.style.color = this.tipColor;
            if (this.broker) { this.broker.showTipApproveCorrect(); }
          }
          break;
        case 'system_brand':
          if (this.broker) { this.broker.showTipBrandWrong(); }
          break;
      }
    }
  }
}
HangmanQuestionWidget.prototype.setCorrectColor = function(correctColor)
{
  //;
  if(correctColor)
  {
    this.correctColor = correctColor;
  }
}
HangmanQuestionWidget.prototype.setWrongColor = function(wrongColor)
{
  //;
  if(wrongColor)
  {
    this.wrongColor = wrongColor;
  }
}
HangmanQuestionWidget.prototype.setTipColor = function(tipColor)
{
  //;
  if(tipColor)
  {
    this.tipColor = tipColor;
  }
}
HangmanQuestionWidget.prototype.setInactiveColor = function(inactiveColor)
{
  //;
  if(inactiveColor)
  {
    this.inactiveColor = inactiveColor;
  }
}
HangmanQuestionWidget.prototype.reset = function()
{
   this.aHaveAlreadyBeenTipped = new Array();
   this.bIsTip = false;
}
