/*
<DEPENDENCIES>
    <DEPENDS>Logger</DEPENDS>
    <DEPENDS>Browser</DEPENDS>
    <DEPENDS>Answer</DEPENDS>
    <DEPENDS>Question</DEPENDS>
    <DEPENDS>Evaluation</DEPENDS>
    <DEPENDS>HangmanQuestionWidget</DEPENDS>
    <DEPENDS>HangmanKeyAdapter</DEPENDS>
</DEPENDENCIES>
*/
function HangmanManager(sId, sQuestionContainerDomId, sQuestionTemplateDomId, sHangmanEvaluateCorrectPicDomId, sHangmanEvaluateWrongPicDomId)
{
  if (sId) { this.init(sId, sQuestionContainerDomId, sQuestionTemplateDomId, sHangmanEvaluateCorrectPicDomId, sHangmanEvaluateWrongPicDomId); }
}
HangmanManager.prototype.init = function(sId, sQuestionContainerDomId, sQuestionTemplateDomId, sHangmanEvaluateCorrectPicDomId, sHangmanEvaluateWrongPicDomId)
{
  ;   
  this.sId = sId;
  this.aWrongIndicators = new Array();
  this.workItem = null;
  this.oKeyboardManager = null;
  this.oWrongIndicatorManager = null;
  this.aValidKeys = new Array();
  this.sAnswer = null;
  this.nPadding = null;
  this.nSpacing = null;
  this.correctColor = null;
  this.wrongColor = null;
  this.tipColor = null;
  this.inactiveColor = null;
  this.aQuestionWidgets = new Array();
  this.aHangmanKeyAdapterText = new Array();
  this.sHangmanEvaluateCorrectPicDomId = sHangmanEvaluateCorrectPicDomId;
  this.oHangmanEvaluatePic = document.getElementById(sHangmanEvaluateCorrectPicDomId);
  if ( ! this.oHangmanEvaluatePic )
  {
    ;
  }
  this.sHangmanEvaluateWrongPicDomId = sHangmanEvaluateWrongPicDomId;
  this.oHangmanEvaluateWrongPic = document.getElementById(sHangmanEvaluateWrongPicDomId);
  if ( ! this.oHangmanEvaluateWrongPic )
  {
    ;
  }
  this.sQuestionContainerDomId = sQuestionContainerDomId;
  this.oQuestionContainer = document.getElementById(sQuestionContainerDomId);
  if ( ! this.oQuestionContainer )
  {
    ;
  }
  this.sQuestionTemplateDomId = sQuestionTemplateDomId;
  this.oQuestionTemplate = document.getElementById(sQuestionTemplateDomId);
  if ( ! this.oQuestionTemplate )
  {
    ;
  }
}
HangmanManager.prototype.start = function()
{
  ;   
  this.aValidKeys = this.oKeyboardManager.getValidKeys();
  var oLastNode = null;
  var nNumberInLine = 0;
  var inactiveColor = Browser.getComputedStyleById(this.oQuestionTemplate.id,'color');
  var pAbsPosOfQuestionBox = new Point(0,0);
  var widthOfQuestionWidget = parseInt(Browser.getComputedStyleById(this.oQuestionTemplate.id, 'width'));
  var widthOfQuestionWidgetContainer = parseInt(Browser.getComputedStyleById(this.oQuestionContainer.id, 'width'));
  Browser.getAbsPos(this.oQuestionContainer, pAbsPosOfQuestionBox);
  if (inactiveColor)
  {
    this.inactiveColor = inactiveColor;
  }
  for ( var i = 0; i < this.sAnswer.length;  i++)
  {
    nNumberInLine++;
    var bValidKey = false;
    for ( var j = 0; j < this.aValidKeys.length; j++)
    {
      if ( this.sAnswer.charAt(i) == this.aValidKeys[j] )
      {
        bValidKey = true;
        break;
      }
    }
    var oNewNode = this.oQuestionTemplate.cloneNode(true);
    oNewNode.style.position = 'absolute';
    oNewNode.id = oNewNode.id + '_' + i;
    this.oQuestionContainer.appendChild(oNewNode);
    Browser.changePixelStyle(oNewNode, 'top', 0);
    if ( oLastNode )
    {
      Browser.changePixelStyle(oNewNode, 'left', Browser.getPixelStyle(oLastNode, 'left') + widthOfQuestionWidget + this.nPadding);
    }
    else
    {
      var pAbsPosOfQuestionTemplate = new Point(0,0);
      Browser.changePixelStyle(oNewNode, 'left', 0);
      Browser.getAbsPos(oNewNode, pAbsPosOfQuestionTemplate);
      Browser.changePixelStyle(oNewNode, 'left', (pAbsPosOfQuestionBox.x - pAbsPosOfQuestionTemplate.x) + Math.round(widthOfQuestionWidgetContainer / 2) - Math.round(this.sAnswer.length * ( widthOfQuestionWidget + this.nPadding )/2));
    }
    oLastNode = oNewNode;
    if (bValidKey) 
    {
      var oQuestion = new Question(this.sId + '_q_' + i + this.sAnswer.charAt(i) + j , 1000);
      var oAnswer = this.workItem.getOrCreateAnswerByText(this.sAnswer.charAt(i));
      var oEvaluation = new Evaluation( this.sId + '_e_' + i + this.sAnswer.charAt(i) + j, oQuestion, oAnswer, true, true);
      this.workItem.registerQuestion(oQuestion);
      this.workItem.registerEvaluation(oEvaluation);
      oAnswer.start();
      oEvaluation.start();
      oQuestion.start();
      oHangmanQuestionWidget = new HangmanQuestionWidget(this.sId + '_e_' + i + this.sAnswer.charAt(i) + j, oNewNode.id);
      this.aQuestionWidgets.push(oHangmanQuestionWidget);
      oHangmanQuestionWidget.setCorrectColor(this.correctColor);
      oHangmanQuestionWidget.setWrongColor(this.wrongColor);
      oHangmanQuestionWidget.setTipColor(this.tipColor);
      oHangmanQuestionWidget.setInactiveColor(this.inactiveColor);
      oQuestion.registerStatusChangeListener(oHangmanQuestionWidget);
      oHangmanQuestionWidget.setManager(this);
      var bFound = false;
      for ( var k in this.aHangmanKeyAdapterText )
      {
        if (this.aHangmanKeyAdapterText[k] == this.sAnswer.charAt(i))
        {
          bFound = true;
          break;
        }
      }
      if ( ! bFound )
      {
        var oHangmanKeyAdapter = new HangmanKeyAdapter(this.sId + '_HKA_' + i + this.sAnswer.charAt(i) + j);
        oHangmanKeyAdapter.setManager(this);
        oAnswer.registerStatusChangeListener(oHangmanKeyAdapter);
        this.aHangmanKeyAdapterText.push(this.sAnswer.charAt(i));
      }
    }
    else
    {
      oNewNode.innerHTML = this.sAnswer.charAt(i);
      oNewNode.style.border = '0px';
      this.oQuestionContainer.appendChild(oNewNode);
    }
  }
  Browser.removeNodeFromParent(this.oQuestionTemplate);
}
HangmanManager.prototype.getId = function()
{
  //;
  return this.sId;
}
HangmanManager.prototype.setWorkItem = function(workItem)
{
  //;
  this.workItem = workItem;
  this.workItem.setCountDynamicAnswersWrong(true);
}
HangmanManager.prototype.setAnswerString = function(sAnswer)
{
  //;
  this.sAnswer = sAnswer;
}
HangmanManager.prototype.setPadding = function(nPadding)
{
  //;
  this.nPadding = nPadding;
}
HangmanManager.prototype.setSpacing = function(nSpacing)
{
  //;
  this.nSpacing = nSpacing;
}
HangmanManager.prototype.setKeyboardManager = function(oKeyboardManager)
{
  ;
  this.oKeyboardManager = oKeyboardManager;
}
HangmanManager.prototype.setWrongIndicatorManager = function(oWrongIndicatorManager)
{
  ;
  this.oWrongIndicatorManager = oWrongIndicatorManager;
  this.oWrongIndicatorManager.setManager(this);
}
HangmanManager.prototype.wrongChangeInHangmanQuestionWidget = function(sChar)
{
  ;
  if ( this.oWrongIndicatorManager)
  {
    this.oWrongIndicatorManager.wrongChangeInHangmanQuestionWidget(sChar);
  }
}
HangmanManager.prototype.workDone = function()
{
  ;
  this.oHangmanEvaluatePic.style.visibility = 'hidden';
  this.oHangmanEvaluateWrongPic.style.visibility = 'inherit';
  this.workItem.evaluate();
}
HangmanManager.prototype.reset = function()
{
  ;
  this.oHangmanEvaluateWrongPic.style.visibility = 'hidden';
  this.oHangmanEvaluatePic.style.visibility = 'inherit';
  for(var i in this.aQuestionWidgets)
  {
    this.aQuestionWidgets[i].reset();
  }
}
HangmanManager.prototype.addChar = function(sChar)
{
  ;
  var bValidKey = false;
  if ( sChar )
  {
    for ( var i in this.aValidKeys )
    {
      if ( this.aValidKeys[i] == sChar )
      {
        bValidKey = true;
        break;
      }
    }
  }
  if ( bValidKey )
  {
    var oAnswer = this.workItem.getAnswerByText( sChar );
    if ( oAnswer )
    {
      var nCorrect = oAnswer.countCorrectEvaluations();
      if ( nCorrect )
      { 
        var oQuestion = null;
        for( i = 0; i < nCorrect; i++)
        {
          oQuestion = oAnswer.getNextSolutionComplement(oQuestion);
          this.workItem.assign(oQuestion, oAnswer);
        }
      }
      else
      {
        for (i in this.workItem.aQuestions )
        {
          if( this.workItem.aQuestions[i].getId() != 'OffQuestion')
          {
            this.workItem.assign(this.workItem.aQuestions[i], oAnswer);
            break;
          }
        }
      }
    }
    else
    {
      oAnswer = this.workItem.getOrCreateAnswerByText( sChar );
      var bFound = false;
      for ( var k in this.aHangmanKeyAdapterIds )
      {
        if (this.aHangmanKeyAdapterText[k] == sChar)
        {
          bFound = true;
          break;
        }
      }
      if ( ! bFound )
      {
        var oHangmanKeyAdapter = new HangmanKeyAdapter(this.sId + '_HKA_' + sChar);
        oHangmanKeyAdapter.setManager(this);
        oAnswer.registerStatusChangeListener(oHangmanKeyAdapter);
        this.aHangmanKeyAdapterText.push(sChar);
      }
      for (i in this.workItem.aQuestions )
      { 
        if( this.workItem.aQuestions[i].getId() != 'OffQuestion')
        {
          this.workItem.assign(this.workItem.aQuestions[i], oAnswer);
          break;
        }
      }
    }
  }
}
HangmanManager.prototype.enableKeyWidgetByText = function(sText, bEnable)
{
  ;
  if(this.oKeyboardManager)
  {
    this.oKeyboardManager.enableKeyWidgetByText( sText, bEnable );
  }
}
HangmanManager.prototype.setCorrectColor = function(correctColor)
{
  //;
  if(correctColor)
  {
    this.correctColor = correctColor;
  }
}
HangmanManager.prototype.setWrongColor = function(wrongColor)
{
  //;
  if(wrongColor)
  {
    this.wrongColor = wrongColor;
  }
}
HangmanManager.prototype.setTipColor = function(tipColor)
{
  //;
  if(tipColor)
  {
    this.tipColor = tipColor;
  }
}
HangmanManager.prototype.getAddCharAction = function(sChar)
{
    return new ObjectMethodAction(this, "addChar", sChar);
}
