/*
<DEPENDENCIES>
    <DEPENDS>Browser</DEPENDS>
    <DEPENDS>Logger</DEPENDS>
</DEPENDENCIES>
*/
function HighlighterChar(sId, sHighlighterWidgetDomId, sChar, nPos)
{
  if (sId) { this.init(sId, sHighlighterWidgetDomId, sChar, nPos); }
}
HighlighterChar.prototype.init = function(sId, sHighlighterCharDomId, sChar, nPos)
{
  ;
  this.sId = sId;
  this.sChar = sChar;
  this.nPos = nPos; 
  this.modelItem = null;
  this.workItem = null;
  this.oManager = null;
  this.oHighlighterChar = null;
  this.sModelActive = null;
  this.bActive = null;
  this.sHighlighterCharDomId = sHighlighterCharDomId;
  var me = this;
  this.mouseoverHandlerCallback = function(event)
  {
    me.mouseoverHandler(event);
    return false;
  }
  this.mousedownHandlerCallback = function(event)
  {
    me.mousedownHandler(event);
    return false;
  }
}
HighlighterChar.prototype.start = function()
{
  this.oHighlighterChar = document.getElementById(this.sHighlighterCharDomId);
  if (this.oHighlighterChar == null)
  {
      ;
  }
  Browser.addEventListenerToDomNode(this.oHighlighterChar, Browser.eventNames.MOUSEOVER, this.mouseoverHandlerCallback);
  Browser.addEventListenerToDomNode(this.oHighlighterChar, Browser.eventNames.MOUSEDOWN, this.mousedownHandlerCallback);
}
HighlighterChar.prototype.getId = function()
{
  //;
  return this.sId;
}
HighlighterChar.prototype.setModelItem = function(modelItem)
{
  //;
  this.modelItem = modelItem;
}
HighlighterChar.prototype.setManager = function(oManager)
{
  //;
  this.oManager = oManager;
}
HighlighterChar.prototype.setChar = function(sChar)
{
  //;
  this.sChar = sChar;
}
HighlighterChar.prototype.getChar = function()
{
  //;
  return this.sChar;
}
HighlighterChar.prototype.getModelItem = function()
{
  //;
  return this.modelItem;
}
HighlighterChar.prototype.changed = function(model)
{
  ;
  if (model.isEvaluated())
  {
    if ( model.getEvaluation() ) 
    {
      var bActive = model.getEvaluation().isActive();
      var bCorrect = model.getEvaluation().isCorrect();
      if ((bActive && bCorrect) && ! model.getEvaluation().hasOffItem())
      {
        if(this.oManager.sFgCorrectColor)
        {
          this.oHighlighterChar.style.color = this.oManager.sFgCorrectColor;
        }
        if(this.oManager.sBgCorrectColor)
        {
          this.oHighlighterChar.style.backgroundColor = this.oManager.sBgCorrectColor;
        }
        if (this.broker) { this.broker.showCorrect(); }
      }
      else if ((bActive && ! bCorrect )||(!bActive && bCorrect) )
      {
        if(this.oManager.sFgWrongColor)
        {
          this.oHighlighterChar.style.color = this.oManager.sFgWrongColor;
        }
        if(this.oManager.sBgWrongColor)
        {
          this.oHighlighterChar.style.backgroundColor = this.oManager.sBgWrongColor;
        }
        if (this.broker) { this.broker.showWrong(); }
      }
      else
      {
      }
    }
  }
  else
  {
    var nCount = 0;
    var aActiveEvals = new Array();
    for ( var i in this.oManager.workItem.aEvaluations )
    {
      if ( this.oManager.workItem.aEvaluations[i].isActive() && ! this.oManager.workItem.aEvaluations[i].hasOffItem() )
      {
        aActiveEvals.push(this.oManager.workItem.aEvaluations[i])
      }
    }
    for ( var i in aActiveEvals)
    {
      var oAnswer = null;
      if (aActiveEvals[i].getAnswer().isAnswer() == 'Highlighter Answer')
      {
        oAnswer = aActiveEvals[i].getAnswer();
      }
      if ( oAnswer && oAnswer.getStartPos() <= this.nPos && oAnswer.getStartPos() + oAnswer.getLength() > this.nPos )
      {
        nCount++
      }
    }
    if (nCount == 0)
    {
        switch (model.getEvaluation().getOrigin())
        {
          case 'system_solution':
            this.setActive(false);
            this.sModelActive = false;
            if (this.broker) { this.broker.showUnassigned(); }
            break;
          default:
            this.setActive(false);
            this.sModelActive = false;
            if (this.broker) { this.broker.showUnassigned(); }
          break;
      }
    }
    else
    {
      if (nCount == 1)
      {
        switch (model.getEvaluation().getOrigin())
        {
          case 'user':
             this.setActive(true)
             this.sModelActive = 'user';
             break;
         case 'system_solution':
            if (this.broker) { this.broker.showTipAssigned(); }
            this.setTipActive(true)
            this.sModelActive = 'system_set';
          break;
          case 'system_set':
            if (this.broker) { this.broker.showSolution(); }
            this.setTipActive(true)
            this.sModelActive = 'system_set';
          break;
          case 'system_approve':
            this.setTipActive(true)
            this.sModelActive = 'system_set';
            if (this.broker) { this.broker.showTipApproveCorrect(); }
            break;
          case 'system_brand':
            if (this.broker) { this.broker.showTipBrandWrong(); }
            break;
        }
      }
      else
      {
        ;
      }
    }
  }
}
HighlighterChar.prototype.mouseoverHandler = function(event)
{
  ;
  this.oManager.mouseoverHighlighterChar(this);
}
HighlighterChar.prototype.mousedownHandler = function(event)
{
  ;
  this.oManager.mouseDownHighlighterChar(this);
}
HighlighterChar.prototype.setActive = function(bActive)
{
  //;
  if ( bActive )
  {
    this.oHighlighterChar.style.color = this.oManager.sFgHighlightColor;
    this.oHighlighterChar.style.backgroundColor = this.oManager.sBgHighlightColor;
  }
  else
  {
    this.oHighlighterChar.style.color = this.oManager.sFgInactiveColor;
    this.oHighlighterChar.style.backgroundColor = this.oManager.sBgInactiveColor;
  }  
  this.bActive = bActive;
}
HighlighterChar.prototype.setTipActive = function(bActive)
{
  //;
  if ( bActive )
  {
    this.oHighlighterChar.style.color = this.oManager.sFgTipColor;
    this.oHighlighterChar.style.backgroundColor = this.oManager.sBgTipColor;
  }
  else
  {
    this.oHighlighterChar.style.color = this.oManager.sFgInactiveColor;
    this.oHighlighterChar.style.backgroundColor = this.oManager.sBgInactiveColor;
  }  
  this.bActive = bActive;
}
HighlighterChar.prototype.setModelInActive = function()
{
 /* //;
  var oAnswer = this.modelItem;
  var oQuestion = this.oManager.oQuestion;
  var oEvaluation = this.oManager.workItem.getEvaluation(oQuestion,oAnswer);
  oEvaluation.setActive(false);*/
  var aActiveEvals = new Array();
  var aMyActiveEvals = new Array();
  for ( var i in this.oManager.workItem.aEvaluations )
  {
    if ( this.oManager.workItem.aEvaluations[i].isActive() && ! this.oManager.workItem.aEvaluations[i].hasOffItem() )
    {
      aActiveEvals.push(this.oManager.workItem.aEvaluations[i])
    }
  }
  for ( var i in aActiveEvals)
  {
    var oAnswer = null;
    if (aActiveEvals[i].getAnswer().isAnswer() == 'Highlighter Answer')
    {
      oAnswer = aActiveEvals[i].getAnswer();
    }
    if ( oAnswer && oAnswer.getStartPos() <= this.nPos && oAnswer.getStartPos() + oAnswer.getLength() > this.nPos )
    {
      aMyActiveEvals.push(aActiveEvals[i]);
    }
  }
  for ( var i in aMyActiveEvals)
  {
    aMyActiveEvals[i].setActive(false);
  }
}
HighlighterChar.prototype.isActive = function()
{
  //;
  return this.bActive;
}
HighlighterChar.prototype.isModelActive = function()
{
  //;
  return this.sModelActive;
}
