/*
<DEPENDENCIES>
    <DEPENDS>Logger</DEPENDS>
    <DEPENDS>Actions</DEPENDS>
    <DEPENDS>PlaylistEntry</DEPENDS>
</DEPENDENCIES>
*/
function PlaylistManager(id)
{
	;
	this.init(id);
}
PlaylistManager.prototype.init = function(id)
{
	;
	this.id = id;
	this.entries = new Array();
	this.numberOfEntries = 0;
}
PlaylistManager.prototype.setBroker = function(broker)
{
	;
	this.broker = broker;
	broker.addRequestPlaylistStartHandle(this.getPlaylistStartAction());
	broker.addRequestPlaylistStopHandle(this.getPlaylistStopAction());
	this.stopped = false;
}
PlaylistManager.prototype.addPlaylistEntry = function(entry)
{
	;
	this.entries[this.numberOfEntries] = entry;
	entry.addStartedHandle(new ObjectMethodAction(this, 'entryStarted', entry))
	entry.addStoppedHandle(new ObjectMethodAction(this, 'entryStopped', entry))
	entry.addFinishedHandle(new ObjectMethodAction(this, 'entryFinished', entry))
	this.numberOfEntries++;
}
PlaylistManager.prototype.start = function()
{
	;
	for (var i = 0; i < this.numberOfEntries; i++)
	{
		this.entries[i].start();
	}
}
PlaylistManager.prototype.getPlaylistStartAction = function()
{
	return new ObjectMethodAction(this, 'startPlaylist');
}
PlaylistManager.prototype.startPlaylist = function()
{
	;
	this.stopped = false;
	this.active = this.entries[0];
	if (this.active)
	{
		this.activeEntry = 0;
		this.active.play();
	}
}
PlaylistManager.prototype.getPlaylistStopAction = function()
{
	return new ObjectMethodAction(this, 'stopPlaylist');
}
PlaylistManager.prototype.stopPlaylist = function()
{
	;
	this.stopped = true;
	if (this.active)
		this.active.stop();
}
PlaylistManager.prototype.entryStarted = function(entry)
{
	
}
PlaylistManager.prototype.entryStopped = function(entry)
{
	var nextEntry = null;
	for (var i = 0; i < this.numberOfEntries; i++)
	{
		if (entry == this.entries[i])
		{
			if (i == this.numberOfEntries - 1)
			{
				
			}
			else
			{
				nextEntry = this.entries[i + 1];
				break;
			}
		}
	}
	if (nextEntry && (this.stopped == false))
	{
		nextEntry.play();
	}
}
PlaylistManager.prototype.entryFinished = function(entry)
{
	
}
