/*
<DEPENDENCIES>
    <DEPENDS>Globals</DEPENDS>
    <DEPENDS>Logger</DEPENDS>
    <DEPENDS>DnDProductDropTarget</DEPENDS>
    <DEPENDS>SnapStrategy</DEPENDS>
</DEPENDENCIES>
*/
ProductGapSnapStrategy.prototype = new SnapStrategy();
ProductGapSnapStrategy.prototype.constructor = ProductGapSnapStrategy;
ProductGapSnapStrategy.superclass = SnapStrategy.prototype;
function ProductGapSnapStrategy( sId, nSnapX, nSnapY, nDistance )
{
  if( sId )
  {
    this.init(sId, nSnapX, nSnapY, nDistance);
  }
}
ProductGapSnapStrategy.prototype.init = function( sId, nSnapX, nSnapY, nDistance )
{
  ;
  ProductGapSnapStrategy.superclass.init.call(this, sId, nSnapX, nSnapY);
  if( nDistance )
  {
    this.nDistance = nDistance;
  }
  else
  {
    ;
  }
}
ProductGapSnapStrategy.prototype.snap = function( dragable )
{
  ;
  var aUsedSlots = new Array();
  var product = null;
  while( (product = this.dropTarget.modelItem.getNextProduct(product)) != null )
  {
    if( product == dragable.modelItem )  
    {
      ;
    }
    else 
    {
      var dragableOfProduct = this.dropTarget.dragnDropManager.getDragableByModel(product);
      if( dragableOfProduct == null )  
      {
        ;
      }
      else 
      {
        if( dragableOfProduct.snapToken ) 
        {
          aUsedSlots[dragableOfProduct.snapToken] = dragableOfProduct;
        }
        else
        {
          ;
        }
      }
    }
  }
  for( var id in aUsedSlots )
  {
    ;
  }
  var nSlot = 0;
  var nMaxSlot = this.getMaxSlotCount(dragable);
  while( nSlot < nMaxSlot )
  {
    var dragableInSlot = aUsedSlots[this.getTokenFromSlot(nSlot)];
    if( dragableInSlot )
    {
    }
    else 
    {
      dragable.snapToken = this.getTokenFromSlot(nSlot);
      dragable.moveToSnapPosition(this.getPosFromSlot(nSlot, dragable));
      break;
    }
    nSlot++;
  }
  if( nSlot > nMaxSlot )
  {
    ;
  }
}
ProductGapSnapStrategy.prototype.getTokenFromSlot = function( nSlot )
{
  return 'slot-' + nSlot;
}
ProductGapSnapStrategy.prototype.getPosFromSlot = function( nSlot, oDragable )
{
  return new Point(this.nSnapX + this.dropTarget.getPos().x + this.nDistance * nSlot,
          this.nSnapY + this.dropTarget.getPos().y + this.nDistance * nSlot);
}
ProductGapSnapStrategy.prototype.getMaxSlotCount = function( oDragable )
{
  return 300;
}
ProductStackedSnapStrategy.prototype = new ProductGapSnapStrategy();
ProductStackedSnapStrategy.prototype.constructor = ProductStackedSnapStrategy;
ProductStackedSnapStrategy.superclass = ProductGapSnapStrategy.prototype;
function ProductStackedSnapStrategy( sId, nSnapX, nSnapY, nDistance )
{
  if( sId ) this.init(sId, nSnapX, nSnapY, nDistance);
}
ProductStackedSnapStrategy.prototype.init = function( sId, nSnapX, nSnapY, nDistance )
{
  ;
  ProductStackedSnapStrategy.superclass.init.call(this, sId, nSnapX, nSnapY, nDistance);
}
ProductVerticalSnapStrategy.prototype = new ProductGapSnapStrategy();
ProductVerticalSnapStrategy.prototype.constructor = ProductVerticalSnapStrategy;
ProductVerticalSnapStrategy.superclass = ProductGapSnapStrategy.prototype;
function ProductVerticalSnapStrategy( sId, nSnapX, nSnapY, nDistance )
{
  if( sId ) this.init(sId, nSnapX, nSnapY, nDistance);
}
ProductVerticalSnapStrategy.prototype.init = function( sId, nSnapX, nSnapY, nDistance )
{
  ;
  ProductVerticalSnapStrategy.superclass.init.call(this, sId, nSnapX, nSnapY, nDistance);
}
ProductVerticalSnapStrategy.prototype.getPosFromSlot = function( nSlot, oDragable )
{
  return new Point(this.nSnapX + this.dropTarget.getPos().x,
          this.nSnapY + this.dropTarget.getPos().y + this.nDistance * nSlot);
}
ProductMatrixFillColumnSnapStrategy.prototype = new ProductGapSnapStrategy();
ProductMatrixFillColumnSnapStrategy.prototype.constructor = ProductMatrixFillColumnSnapStrategy;
ProductMatrixFillColumnSnapStrategy.superclass = ProductGapSnapStrategy.prototype;
function ProductMatrixFillColumnSnapStrategy( sId, nSnapX, nSnapY, nDistance )
{
  if( sId ) this.init(sId, nSnapX, nSnapY, nDistance);
}
ProductMatrixFillColumnSnapStrategy.prototype.init = function( sId, nSnapX, nSnapY, nDistance )
{
  ;
  ProductMatrixFillColumnSnapStrategy.superclass.init.call(this, sId, nSnapX, nSnapY, nDistance);
}
ProductMatrixFillColumnSnapStrategy.prototype.getPosFromSlot = function( nSlot, oDragable )
{
  ;
  var tw = Browser.getPixelComputedStyle(this.dropTarget.dropWidget, 'width');
  var th = Browser.getPixelComputedStyle(this.dropTarget.dropWidget, 'height');
  var dw = Browser.getPixelComputedStyle(oDragable.dragWidget, 'width');
  var dh = Browser.getPixelComputedStyle(oDragable.dragWidget, 'height');
  ;
  var nw = Math.floor(tw / ( dw + this.nDistance ));
  var nh = Math.floor(th / ( dh + this.nDistance ));
  ;
  var col = Math.floor(nSlot / nh);
  var row = nSlot % nh;
  ;
  var point = new Point(this.nSnapX + this.dropTarget.getPos().x + ( this.nDistance + dw ) * col,
          this.nSnapY + this.dropTarget.getPos().y + ( this.nDistance + dh ) * row);
  ;
  return point;
}
ProductMatrixFillColumnSnapStrategy.prototype.getMaxSlotCount = function( oDragable )
{
  ;
  var tw = Browser.getPixelComputedStyle(this.dropTarget.dropWidget, 'width');
  var th = Browser.getPixelComputedStyle(this.dropTarget.dropWidget, 'height');
  var dw = Browser.getPixelComputedStyle(oDragable.dragWidget, 'width');
  var dh = Browser.getPixelComputedStyle(oDragable.dragWidget, 'height');
  ;
  var nw = Math.floor(tw / ( dw + this.nDistance ));
  var nh = Math.floor(th / ( dh + this.nDistance ));
  ;
  return nw * nh;
}
ProductMatrixFillRowSnapStrategy.prototype = new ProductGapSnapStrategy();
ProductMatrixFillRowSnapStrategy.prototype.constructor = ProductMatrixFillRowSnapStrategy;
ProductMatrixFillRowSnapStrategy.superclass = ProductGapSnapStrategy.prototype;
function ProductMatrixFillRowSnapStrategy( sId, nSnapX, nSnapY, nDistance )
{
  if( sId ) this.init(sId, nSnapX, nSnapY, nDistance);
}
ProductMatrixFillRowSnapStrategy.prototype.init = function( sId, nSnapX, nSnapY, nDistance )
{
  ;
  ProductMatrixFillRowSnapStrategy.superclass.init.call(this, sId, nSnapX, nSnapY, nDistance);
}
ProductMatrixFillRowSnapStrategy.prototype.getPosFromSlot = function( nSlot, oDragable )
{
  ;
  var tw = Browser.getPixelComputedStyle(this.dropTarget.dropWidget, 'width');
  var th = Browser.getPixelComputedStyle(this.dropTarget.dropWidget, 'height');
  var dw = Browser.getPixelComputedStyle(oDragable.dragWidget, 'width');
  var dh = Browser.getPixelComputedStyle(oDragable.dragWidget, 'height');
  ;
  var nw = Math.floor(tw / ( dw + this.nDistance ));
  var nh = Math.floor(th / ( dh + this.nDistance ));
  ;
  var col = nSlot % nw;
  var row = Math.floor(nSlot / nw);
  ;
  return new Point(this.nSnapX + this.dropTarget.getPos().x + ( this.nDistance + dw ) * col,
          this.nSnapY + this.dropTarget.getPos().y + ( this.nDistance + dh ) * row);
}
ProductMatrixFillRowSnapStrategy.prototype.getMaxSlotCount = function( oDragable )
{
  ;
  var tw = Browser.getPixelComputedStyle(this.dropTarget.dropWidget, 'width');
  var th = Browser.getPixelComputedStyle(this.dropTarget.dropWidget, 'height');
  var dw = Browser.getPixelComputedStyle(oDragable.dragWidget, 'width');
  var dh = Browser.getPixelComputedStyle(oDragable.dragWidget, 'height');
  ;
  var nw = Math.floor(tw / ( dw + this.nDistance ));
  var nh = Math.floor(th / ( dh + this.nDistance ));
  ;
  return nw * nh;
}
