/*
<DEPENDENCIES>
    <DEPENDS>Logger</DEPENDS>
    <DEPENDS>Action</DEPENDS>
    <DEPENDS>SoundPlayer</DEPENDS>
    <DEPENDS>SoundBroker</DEPENDS>
    <DEPENDS>SoundRecorderBroker</DEPENDS>
    <DEPENDS>SoundRecorder</DEPENDS>
    <DEPENDS>SpeechRecognitionControlBroker</DEPENDS>
    <DEPENDS>SpeechRecognitionBroker</DEPENDS>
    <DEPENDS>SpeechRecognition</DEPENDS>
    <DEPENDS>ObjectMethodAction</DEPENDS>
</DEPENDENCIES>
*/
function SRRoleInterval(sId, sRoleId, nStartTime, nEndTime, sSoundURL, nSRConfidenceLevel)
{
  if (sId) { this.init(sId, sRoleId, nStartTime, nEndTime, sSoundURL, nSRConfidenceLevel); }
}
SRRoleInterval.prototype.init = function(sId, sRoleId, nStartTime, nEndTime, sSoundURL, nSRConfidenceLevel)
{
  ;
  this.sId = sId;
  this.sRoleId = sRoleId;
  this.nStartTime = nStartTime;
  this.nEndTime = nEndTime;
  this.sSoundURL = sSoundURL;
  this.nSRConfidenceLevel = nSRConfidenceLevel;
  this.nIndex = null;
  this.oSpeechRecognition = null;
  this.sSRModelURL = null;
  this.aUtterances = new Array();
  this.oSpeechRecognitionRegistry = null;
  this.sFeedbackDefaultText = '';
  this.oRecognizerControlBroker = null;
  this.oRecognitionBroker = null;
  this.oRecognizer = null;
  this.oPlaySoundBroker = null;
  this.oPlaySoundPlayer = null;
  this.oManager = null;
  this.bIsTouched = false;
  this.oRoleIntervalBroker = null;
  this.bIsActive = false;
  this.bPlay = false;
}
SRRoleInterval.prototype.getId = function()
{
  ;
  return this.sId;
}
SRRoleInterval.prototype.setManager = function(oManager)
{
  ;
  this.oManager = oManager;
}
SRRoleInterval.prototype.setRoleIntervalBroker = function(oRoleIntervalBroker)
{
  ;
  this.oRoleIntervalBroker = oRoleIntervalBroker;
  oRoleIntervalBroker.addRequestSetActiveHandle( this.getRequestSetActiveAction() );
}
SRRoleInterval.prototype.setSoundPlayer = function(oPlaySoundPlayer)
{
  ;
  this.oPlaySoundPlayer = oPlaySoundPlayer;
}
SRRoleInterval.prototype.setSpeechRecognizer = function(oSpeechRecognizer)
{
  ;
  this.oRecognizer = oSpeechRecognizer;
}
SRRoleInterval.prototype.setSpeechRecognition = function(oSpeechRecognitionRegistry, oSpeechRecognition)
{
  this.oSpeechRecognitionRegistry = oSpeechRecognitionRegistry;
  this.oSpeechRecognition = oSpeechRecognition;  
}
SRRoleInterval.prototype.setUtterances = function(aSpeechRecognitionUtterances)
{
  this.aUtterances = aSpeechRecognitionUtterances;
}
SRRoleInterval.prototype.setDefaultFeedback = function(sDefaultFeedback)
{
  this.sFeedbackDefaultText = sDefaultFeedback;
}
SRRoleInterval.prototype.start = function()
{
  ;
  if ( this.oManager )
  {
    this.createSoundPlayer();
    if (!this.oRecognizer)
    {
      this.oRecognizer = new SpeechRecognizer(this.oSpeechRecognitionRegistry, null, this.oSpeechRecognition, false, false);
    }
  }
  else
  {
    ;
  }
}
SRRoleInterval.prototype.createSoundPlayer = function()
{
  ;
  if ( this.oManager )
  {
    if (!this.oPlaySoundPlayer)
    {
      this.oPlaySoundPlayer = new SoundPlayer(this.oManager.oSoundRegistry, this.sSoundURL);
    }
    this.oPlaySoundBroker = new SoundBroker(this.sId + '_sound_broker');
    this.oPlaySoundPlayer.setSoundBroker(this.oPlaySoundBroker);
    this.oPlaySoundBroker.addSoundStoppedHandle(this.getSoundStopAction());
    this.oPlaySoundBroker.addAbsoluteIntervalReachedHandle(this.getTimeChangeAction());
  }
}
SRRoleInterval.prototype.createSpeechRecognizer = function()
{
  ;
  if ( this.oManager )
  {
    if( ! this.oRecognizer )
    {
      ;
      this.oRecognizer = new SpeechRecognizer(this.oSpeechRecognitionRegistry, null, this.oSpeeechRecognition, false, false);
    }
    this.oRecognizerControlBroker = new SpeechRecognitionControlBroker(this.sId + '_sr_control_broker');
    this.oRecognizer.setControlBroker(this.oRecognizerControlBroker);
    this.oRecognitionBroker = new SpeechRecognitionBroker(this.sId + '_sr_broker');
    this.oRecognizer.setRecognitionBroker(this.oRecognitionBroker);
    this.oRecognizerControlBroker.addRecognitionStoppedHandle(this.getSoundStopAction());
    this.oRecognitionBroker.addEarDataRecognizedHandle(new ObjectMethodAction(this, 'recognized'));
  }
}
SRRoleInterval.prototype.play = function()
{
  ;
  this.oManager.timeChange(this.nStartTime);
  this.bIsActive = true;
  this.bPlay = true;
  if(!this.bIsTouched)
  {
      this.bIsTouched = true;
      if ( this.oRoleIntervalBroker )
      {
        this.oRoleIntervalBroker.systemTouched();
      }
  }
  if ( this.oRecSoundBroker )
  {
    this.oRecSoundBroker.requestSoundStart();
  }
  else
  {
    if ( this.oPlaySoundBroker )
    {
      this.oPlaySoundBroker.requestSoundStart();
    }
    else
    {
      this.createSoundPlayer();
      this.oPlaySoundBroker.requestSoundStart();
    }
  }
}
SRRoleInterval.prototype.record = function()
{
  ;
  this.bIsActive = true;
  this.oManager.timeChange(this.nStartTime);
  if(!this.bIsTouched)
  {
      this.bIsTouched = true;
      if ( this.oRoleIntervalBroker )
      {
        this.oRoleIntervalBroker.userTouched();
      }
  }
  if ( this.oRecognizerControlBroker )
  {
    this.oRecognizerControlBroker.requestRecognitionStart();
  }
  else
  {
    this.createSpeechRecognizer();
    this.oRecognizerControlBroker.requestRecognitionStart();
  }
}
SRRoleInterval.prototype.stopRecord = function()
{
  ;
  this.bIsActive = false;
  if( this.oRecognizerControlBroker )
  {
    this.oRecognizerControlBroker.requestRecognitionStop();
  }
  else
  {
    if (this.oPlaySoundBroker)
    {
      this.oPlaySoundBroker.requestSoundStop();
    }
  }
}
SRRoleInterval.prototype.timeChange = function(sAbsoluteTimeReached)
{
  ;
  if ( parseInt(sAbsoluteTimeReached) && this.oManager && this.bPlay)
  {
    this.oManager.timeChange(parseInt(sAbsoluteTimeReached) + parseInt(this.nStartTime) , true);
  }
}
SRRoleInterval.prototype.recognized = function(earData)
{
  ;
  var knownUtterance = false;
  if(this.bIsActive)
  {
    if(earData.getConfidenceLevel() >= this.nSRConfidenceLevel)
    {
      for(var i in this.aUtterances)
      {
        var utterance = this.aUtterances[i];
        if(utterance.getKey() == earData.getWordId())
        {
          knownUtterance = true;
          if(utterance.hasFeedback())
          {
            this.showFeedback(utterance.getFeedback());
          }
          else
          {
            this.clearFeedback();
          }
          if(utterance.isCorrect())
          {
            this.oManager.requestStopRecord();
          }
          break;
        }
      }
    }
  }
  if(!knownUtterance)
  {
    this.showFeedback(this.sFeedbackDefaultText);
  }
}
SRRoleInterval.prototype.showFeedback = function(sFeedbackText)
{
  if(this.oManager)
  {
    this.oManager.showFeedback(sFeedbackText);
  }
}
SRRoleInterval.prototype.clearFeedback = function()
{
  if(this.oManager)
  {
    this.oManager.clearFeedback();
  }
}
SRRoleInterval.prototype.soundStop = function()
{
  ;
  this.bPlay = false;
  if ( this.oManager )
  {
    this.bIsActive = false;
    this.oManager.timeChange(this.nEndTime);
    this.oManager.roleIntervalPlayed(this);
  }
}
SRRoleInterval.prototype.requestSetActive = function()
{
  ;
  if ( this.oManager )
  {
    this.oManager.requestSetRoleIntervalActive(this);
  }
}
SRRoleInterval.prototype.getRequestSetActiveAction = function()
{
  return new ObjectMethodAction(this, "requestSetActive");
}
SRRoleInterval.prototype.getTimeChangeAction = function()
{
  return new ObjectMethodAction(this, "timeChange");
}
SRRoleInterval.prototype.getSoundStopAction = function()
{
  return new ObjectMethodAction(this, "soundStop");
}
