/*
<DEPENDENCIES>
    <DEPENDS>Logger</DEPENDS>
    <DEPENDS>Actions</DEPENDS>
</DEPENDENCIES>
*/
function SoundPlayer(playerregistry, soundurl, handleName, skipmillis)
{
    ;
    this.init(playerregistry, soundurl, handleName, skipmillis);
}
SoundPlayer.prototype.init = function(playerregistry, soundurl, handleName, skipmillis) {
  ;
  this.soundurl    = soundurl;
  this.isStarted   = false;
  this.isStopped   = false;
  this.isPaused    = false;
  this.isReset     = true;  
  this.actPosition = 0;     
  ;
  this.playerregistry = playerregistry;
  if (skipmillis == undefined)
    this.skipmillis = 2000;
  else
    this.skipmillis = skipmillis;
  this.soundhandle = null;
  try
  {
      ;
      this.soundhandle = playerregistry.register(this, handleName);
  }
  catch (e)
  {
      ;
  }
}
SoundPlayer.prototype.setSoundBroker = function(broker)
{
  this.soundBroker = broker;
  broker.addRequestSoundStartHandle(this.getSoundStartAction());
  broker.addRequestSoundStopHandle(this.getSoundStopAction());
  broker.addRequestSoundPauseHandle(this.getSoundPauseAction());
  broker.addSetTimePositionAbsoluteHandle(this.getSetTimePositionAbsoluteAction());
  broker.addRequestSoundForwardHandle(this.getSoundForwardAction());
  broker.addRequestSoundRewindHandle(this.getSoundRewindAction());
}
SoundPlayer.prototype.stopped = function() {
  return this.isStopped;
}
SoundPlayer.prototype.paused = function() {
  return this.isPaused;
}
SoundPlayer.prototype.position = function() {
  return this.actPosition;
}
SoundPlayer.prototype.setStatus = function(newstatus) {
  if (newstatus == "started") {
    this.isStarted   = true;
    this.isStopped   = false;
    this.isPaused    = false;
    this.isReset     = false;
    this.actPosition = 0;
  }
  else if (newstatus == "stopped") {
    this.isStarted   = false;
    this.isStopped   = true;
    this.isPaused    = false;
    this.isReset     = false;
    this.actPosition = 0;
  }
  else if (newstatus == "paused") {
    this.isStarted   = false;
    this.isStopped   = false;
    this.isPaused    = true;
    this.isReset     = false;
    this.actPosition = 0;
  }
  else if (newstatus == "reset") {
    this.isStarted   = false;
    this.isStopped   = false;
    this.isPaused    = false;
    this.isReset     = true;
    this.actPosition = 0;
  }
  else if (newstatus.indexOf("position") >= 0) {
    this.actPosition = parseInt(newstatus.substring(8));
  }
}
SoundPlayer.prototype.getSoundStartAction = function() {
    return new ObjectMethodAction(this, 'play');
}
SoundPlayer.prototype.getSoundStopAction = function() {
    return new ObjectMethodAction(this, 'stop');
}
SoundPlayer.prototype.getSoundPauseAction = function() {
    return new ObjectMethodAction(this, 'pause');
}
SoundPlayer.prototype.getSoundRewindAction = function() {
    return new ObjectMethodAction(this, 'rewind', this.skipmillis);
}
SoundPlayer.prototype.getSoundForwardAction = function() {
    return new ObjectMethodAction(this, 'forward', this.skipmillis);
}
SoundPlayer.prototype.getSetTimePositionAbsoluteAction = function(millis) {
    return new ObjectMethodAction(this, 'setTimePositionAbsolute', millis);
}
SoundPlayer.prototype.play = function() {
  ;
  this.soundhandle.play();
}
SoundPlayer.prototype.stop = function() {
  this.soundhandle.stop();
}
SoundPlayer.prototype.pause = function() {
    this.soundhandle.pause();
}
SoundPlayer.prototype.rewind = function(amount) {
  this.soundhandle.rewind(amount);
}
SoundPlayer.prototype.forward = function(amount) {
  this.soundhandle.forward(amount);
}
SoundPlayer.prototype.getLength = function() {
  return this.soundhandle.getlength();
}
SoundPlayer.prototype.setTimePositionAbsolute = function(time) {
  this.soundhandle.setTimePositionAbsolute(time);
}
