/*
<DEPENDENCIES>
    <DEPENDS>Logger</DEPENDS>
    <DEPENDS>Globals</DEPENDS>
    <DEPENDS>BasicQeaCorrectionStrategy</DEPENDS>
    <DEPENDS>LastAssignmentQeaCorrectionStrategyHandle</DEPENDS>
</DEPENDENCIES>
*/
LastAssignedEvaluationQeaCorrectionStrategy.prototype             = new BasicQeaCorrectionStrategy();
LastAssignedEvaluationQeaCorrectionStrategy.prototype.constructor = LastAssignedEvaluationQeaCorrectionStrategy;
LastAssignedEvaluationQeaCorrectionStrategy.superclass            = BasicQeaCorrectionStrategy.prototype;
function LastAssignedEvaluationQeaCorrectionStrategy(sId, nRemoveWrongTime, bShowCorrect, nShowCorrectTime)
{
  this.init(sId, nRemoveWrongTime, bShowCorrect, nShowCorrectTime)
}
LastAssignedEvaluationQeaCorrectionStrategy.prototype.init = function(sId, nRemoveWrongTime, bShowCorrect, nShowCorrectTime)
{
  ;
  this.nRemoveWrongTime = nRemoveWrongTime;
  this.nShowCorrectTime = nShowCorrectTime;
  this.bShowCorrect = bShowCorrect;
  this.nHandles = 0;
  LastAssignedEvaluationQeaCorrectionStrategy.superclass.init.call(this, sId);
}
LastAssignedEvaluationQeaCorrectionStrategy.prototype.showCorrection = function()
{
  ;
  var lastEvaluation = this.getLastEvaluation();
  if(lastEvaluation)
  {
    var sHandleId = this.sId + '_' + this.nHandles++;
    var oHandle = new LastAssignedEvaluationQeaCorrectionStrategyHandle(sHandleId, this, lastEvaluation);
    oHandle.showCorrection();
  }
}
var staticLastAssignedEvaluationQeaCorrectionStrategyHandle = new Array();
LastAssignedEvaluationQeaCorrectionStrategyHandle.prototype             = new LastAssignmentQeaCorrectionStrategyHandle();
LastAssignedEvaluationQeaCorrectionStrategyHandle.prototype.constructor = LastAssignedEvaluationQeaCorrectionStrategyHandle;
LastAssignedEvaluationQeaCorrectionStrategyHandle.superclass            = LastAssignmentQeaCorrectionStrategyHandle.prototype;
LastAssignedEvaluationQeaCorrectionStrategyHandle_getInstance = function(sId)
{
  var Instance = null;
  if ( staticLastAssignedEvaluationQeaCorrectionStrategyHandle[sId] )
  {
    Instance = staticLastAssignedEvaluationQeaCorrectionStrategyHandle[sId];
  }
  return Instance;
}
function LastAssignedEvaluationQeaCorrectionStrategyHandle(sId, strategy, lastEvaluation)
{
  this.sId = sId;
  this.strategy = strategy;
  this.lastEvaluation = lastEvaluation;
  this.aTimerEvaluations = new Array();
  staticLastAssignedEvaluationQeaCorrectionStrategyHandle[sId] = this;
}
LastAssignedEvaluationQeaCorrectionStrategyHandle.prototype.init = function(sId, strategy, lastEvaluation)
{
  ;
  LastAssignedEvaluationQeaCorrectionStrategyHandle.superclass.init.call(sId, strategy, lastEvaluation);
}
LastAssignedEvaluationQeaCorrectionStrategyHandle.prototype.removeWrong = function()
{
  ;
  var evaluation = this.aTimerEvaluations.pop();
  evaluation.setActive(false, 'system_set');
  if( this.strategy.bShowCorrect )
  {
    var workItem = this.strategy.getLastWorkItem();
    var question = evaluation.getQuestion();
    var answer = evaluation.getAnswer();
    var aEvaluations = workItem.getEvaluations(question, answer);
    var solutionEvaluation = null;
    for(var i in aEvaluations)
    {
      var e = aEvaluations[i];
      if(e != evaluation)
      {
        solutionEvaluation = e;
        break
      }
    }
    if ( solutionEvaluation != null )
    {
      this.aTimerEvaluations.push(solutionEvaluation);
      window.setTimeout('LastAssignedEvaluationQeaCorrectionStrategyHandle_getInstance(\''+this.sId+'\').showCorrect();', this.strategy.nShowCorrectTime);
    }
  }
  else
  {
    this.strategy.exerciseManager.endCorrection();
  }
}
LastAssignedEvaluationQeaCorrectionStrategyHandle.prototype.hasCorrection = function()
{
  ;
  var bHasCorrection = true;
  if (! (bHasCorrection && this.lastEvaluation))
  {
    bHasCorrection = false;
  }
  return bHasCorrection;
}
LastAssignedEvaluationQeaCorrectionStrategyHandle.prototype.showCorrection = function()
{
  ;
  var lastEvaluation = null;
  if (this.hasCorrection())
  {
    lastEvaluation = this.lastEvaluation;
  }
  if ( lastEvaluation )
  {
    if ( lastEvaluation.isCorrect() )
    {
      if ( lastEvaluation.isActive() )
      {
        var bSystemConstructive = lastEvaluation.bSystemConstructive;
        lastEvaluation.setActive(true, 'system_approve');
        lastEvaluation.bSystemConstructive = bSystemConstructive;
        lastEvaluation.workItem.changed(lastEvaluation);
        this.lastTippedEvaluation = lastEvaluation;
      }
      else
      {
      }
    }
    else
    {
      if( lastEvaluation.isActive() )
      {
        this.strategy.exerciseManager.beginCorrection();
        var bSystemConstructive = lastEvaluation.bSystemConstructive;
        lastEvaluation.setSilentlyActive(true, 'system_brand');
        lastEvaluation.bSystemConstructive = bSystemConstructive;
        lastEvaluation.workItem.changed(lastEvaluation);
        this.aTimerEvaluations.push(lastEvaluation);
        this.lastTippedEvaluation = lastEvaluation;
        window.setTimeout('LastAssignedEvaluationQeaCorrectionStrategyHandle_getInstance(\''+this.sId+'\').removeWrong();', this.strategy.nRemoveWrongTime);
      }
      else
      {
      }
    }
  }
}
LastAssignedEvaluationQeaCorrectionStrategyHandle.prototype.showCorrect = function()
{
  ;
  var evaluation = this.aTimerEvaluations.pop();
  evaluation.setActive(true, 'system_approve');
  this.lastTippedEvaluation = evaluation;
  this.strategy.exerciseManager.endCorrection();
}
