/*
<DEPENDENCIES>
    <DEPENDS>Logger</DEPENDS>
    <DEPENDS>ValueItem</DEPENDS>
</DEPENDENCIES>
*/
MatcherValueItem.prototype             = new ValueItem();
MatcherValueItem.prototype.constructor = MatcherValueItem;
MatcherValueItem.superclass            = ValueItem.prototype;
function MatcherValueItem(sId) 
{
    this.init(sId);
}
MatcherValueItem.prototype.init = function(sId)
{
  ;
  MatcherValueItem.superclass.init.call(this, sId);
  this.sValue = ''; 
  this.aCorrectOptions = new Array();
  this.nCorrectOptions = 0;
  this.sPreferredValue = ''; 
  this.bSystemContributedConstructive = false;
  this.bSystemContributedCorrective = false;
}
MatcherValueItem.prototype.toString = function()
{
  var s = 'MatcherValueItem' +
          ' id=' + this.sId +
          ' value=' + this.getValue() +
          ' origin=' + this.getOrigin() +
          ' solved=' + this.isSolved() +
          ' ';
  return s;
}
MatcherValueItem.prototype.registerCorrectOptionItem = function(optionItem, bPreferred)
{
  ;
  if (this.sPreferredValue == '') { bPreferred = true; }
  if (bPreferred)
  {
    ;
    this.sPreferredValue = optionItem.getId();
  }
  if (this.aCorrectOptions[optionItem.getId()] != null)
  {
    ;
  }
  else
  {
    ;
    this.aCorrectOptions[optionItem.getId()] = optionItem;
    this.nCorrectOptions++;
    optionItem.registerValueItem(this, bPreferred);
  }
}
MatcherValueItem.prototype.getSolution = function()
{
  return this.sPreferredValue;
}
MatcherValueItem.prototype.hasSolution = function()
{
  var bHas = true;
  var sValue = this.getSolution();
  if (sValue == null || sValue == '')
  {
    bHas = false;
  }
  return bHas;
}
MatcherValueItem.prototype.isSolution = function(optionId)
{
  //;
  var bIsSolution = false;
  if (this.nCorrectOptions == 0 && optionId == '')
  {
    bIsSolution = true;
  }
  else
  {
    for (var id in this.aCorrectOptions)
    {
      //;
      if (optionId == id)
      {
        //;
        bIsSolution = true;
        break;
      }
    }
  }
  return bIsSolution;
}
MatcherValueItem.prototype.isSolved = function()
{
  return this.isSolution(this.sValue);
}
MatcherValueItem.prototype.getValue = function()
{
  return this.sValue;
}
MatcherValueItem.prototype.hasConstructiveSystemContribution = function()
{
  return this.bSystemContributedConstructive;
}
MatcherValueItem.prototype.hasCorrectiveSystemContribution = function()
{
  return this.bSystemContributedCorrective;
}
MatcherValueItem.prototype.hasSystemContribution = function()
{
  return this.hasConstructiveSystemContribution() || this.hasCorrectiveSystemContribution();
}
MatcherValueItem.prototype.setValue = function(sOptionId, sOrigin)
{
  ;
  var sOldValue = this.sValue;
  var sOldOrigin = this.sOrigin;
  var bAssign = false;
  var newOptionItem = null;
  var oldOptionItem = null;
  if (sOldValue != '')
  {
    oldOptionItem = this.workItem.aOptions[sOldValue];
    if (oldOptionItem == null)
    {
      ;
    }
  }
  if (sOptionId == '')
  {
    bAssign = true;
  }
  else
  {
    newOptionItem = this.workItem.aOptions[sOptionId];
    if (newOptionItem != null)
    {
      bAssign = newOptionItem.assignable(this);
      if (!bAssign)
      {
        ;
      }
    }
    else
    {
      ;
    }
  }
  if (bAssign)
  {
    this.sValue = sOptionId;
    this.sOrigin = sOrigin;
    switch (sOrigin)
    {
      case 'user':
        this.bUserContributed = true;
        break;
      case 'system':
        if (this.getSolution() == '' && sOptionId == '')
        {
          if (sOldValue == '')
          {
            this.bSystemContributedConstructive = true;
            this.bSystemContributedCorrective = false;
          }
          else
          {
            this.bSystemContributedConstructive = false;
            this.bSystemContributedCorrective = true;
          }
        }
        else
        {
          this.bSystemContributedConstructive = this.isSolved();
          this.bSystemContributedCorrective = !this.isSolved();
        }
        break;
    }
    if (oldOptionItem != null)
    {
      oldOptionItem.unassigned(this);
    }
    if (newOptionItem != null)
    {
      newOptionItem.assigned(this);
    }
    if (sOldValue != sOptionId || sOldOrigin != this.sOrigin)
    {
      this.onChanged();
    }
  }
}
MatcherValueItem.prototype.setValueByUser = function(sOptionId)
{
  //;
  this.setValue(sOptionId, 'user');
}
MatcherValueItem.prototype.setValueBySystem = function(sOptionId)
{
  //;
  this.setValue(sOptionId, 'system');
}
function MatcherOptionItem(sId, bCorrectOnly, bReusable)
{
  this.init(sId, bCorrectOnly, bReusable);
}
MatcherOptionItem.prototype.init = function(sId, bCorrectOnly, bReusable)
{
  ;
  this.sId = sId;
  this.bCorrectOnly = bCorrectOnly; 
  this.bReusable = bReusable; 
  this.bUsedAtLeastOnce = false; 
  this.sCurrentValue = ''; 
  this.sPreferredValue = '';
  this.aValueItems = new Array();
  this.nValueItems = 0;
  this.aSCListener = new Array(); 
  this.nSCListener = 0;
}
MatcherOptionItem.prototype.getId = function()
{
  return this.sId;
}
MatcherOptionItem.prototype.setWorkItem = function(workItem)
{
  ;
  this.workItem = workItem;
}
MatcherOptionItem.prototype.registerStatusChangeListener = function(scListener)
{
  ;
  if (this.aSCListener[scListener.getId()] != null)
  {
    ;
  }
  else
  {
    this.aSCListener[scListener.getId()] = scListener;
    this.nSCListener++;
    ;
    scListener.setOptionItem(this);
  }
}
MatcherOptionItem.prototype.registerValueItem = function(valueItem, bPreferred)
{
  ;
  if (this.sPreferredValue == '') { bPreferred = true; }
  if (bPreferred)
  {
    ;
    this.sPreferredValue = valueItem.getId();
  }
  if (this.aValueItems[valueItem.getId()] != null)
  {
    ;
  }
  else
  {
    ;
    this.aValueItems[valueItem.getId()] = valueItem;
    this.nValueItems++;
  }
}
MatcherOptionItem.prototype.start = function()
{
  ;
}
MatcherOptionItem.prototype.getSolution = function()
{
  return this.sPreferredValue;
}
MatcherOptionItem.prototype.getCurrentValue = function()
{
  return this.sCurrentValue;
}
MatcherOptionItem.prototype.assignable = function(valueItem)
{
  ;
  var result = true;
  if (!this.bReusable && this.sCurrentValue != '')
  {
    result = false;
    ;
  }
  if (result && this.bCorrectOnly)
  {
    var a = this.aValueItems[valueItem.getId()];
    if (a == null)
    {
      result = false;
      ;
    }
  }
  return result;
}
MatcherOptionItem.prototype.assigned = function(valueItem)
{
  ;
  ;
  if (this.sCurrentValue != '')
  {
    this.workItem.aValues[this.sCurrentValue].setValue('');
  }
  this.sCurrentValue = valueItem.getId();
  this.bUsedAtLeastOnce = true;
  ;
  for (var id in this.aSCListener)
  {
    if (this.aSCListener[id] != null)
    {
      this.aSCListener[id].changed(this);
    }
  }
}
MatcherOptionItem.prototype.unassigned = function(valueItem)
{
  ;
  if (this.sCurrentValue != valueItem.getId())
  {
    ;
  }
  else
  {
    ;
    this.sCurrentValue = '';
    ;
    for (var id in this.aSCListener)
    {
      if (this.aSCListener[id] != null)
      {
        this.aSCListener[id].changed(this);
      }
    }
  }
}
