/*
<DEPENDENCIES>
    <DEPENDS>Logger</DEPENDS>
    <DEPENDS>Globals</DEPENDS>
    <DEPENDS>BasicQeaTipStrategy</DEPENDS>
</DEPENDENCIES>
*/
SwitchOrderedDragablesQeaTipStrategy.prototype             = new BasicQeaTipStrategy();
SwitchOrderedDragablesQeaTipStrategy.prototype.constructor = SwitchOrderedDragablesQeaTipStrategy;
SwitchOrderedDragablesQeaTipStrategy.superclass            = BasicQeaTipStrategy.prototype;
function SwitchOrderedDragablesQeaTipStrategy(sId)
{
  this.init(sId)
}
SwitchOrderedDragablesQeaTipStrategy.prototype.init = function(sId)
{
  ;
  if ( ! this.sCycleTipsUndoSentinel )
  { 
    this.sCycleTipsUndoSentinel = 'correct_wrong_qea_system_cycletip_sentinel'
  }
  SwitchOrderedDragablesQeaTipStrategy.superclass.init.call(this, sId);
}
SwitchOrderedDragablesQeaTipStrategy.prototype.evaluationHasTip = function(evaluation, bStepByStep)
{
  ;
  var bHasTip = true;
  if (bHasTip)
  {
    bHasTip = evaluation.isSolution() && evaluation.isCorrect() && !evaluation.isActive();
  }
  if (bHasTip)
  {
    bHasTip = evaluation.canSetActive(true);
  }
  var wrongEval = null;
  if (bHasTip)
  {
    var evaluations = evaluation.workItem.aEvaluations;
    var question = evaluation.getQuestion();
    var answer = evaluation.getAnswer();
    for(var i in evaluations)
    {
      var eval = evaluations[i];
      if(eval.isActive() && !eval.isCorrect() && evaluations[i].getQuestion() == question)
      {
        wrongEval = evaluations[i];
        break;
      }
    }
    if ( ! wrongEval )
    {
      bHasTip = false;
    }
  }
  if (bHasTip)
  {
    if (! ( evaluation.getQuestion().getMax() == 1 || evaluation.getAnswer().getMax() == 1 )) 
    {
      bHasTip = false;
    }
  }
  return bHasTip;
}
SwitchOrderedDragablesQeaTipStrategy.prototype.evaluationShowTip = function(evaluation, bStepByStep)
{
  ;
  var question = evaluation.getQuestion();
  var answer = evaluation.getAnswer();
  var evaluations = evaluation.workItem.aEvaluations;
  var otherAnswer = null;
  var otherQuestion = null;
  for(var i in evaluations)
  {
    var eval = evaluations[i];
    if((eval != evaluation) && (eval.isActive()) && (eval.getQuestion() == question) && (eval.getAnswer() != answer))
    {
       otherAnswer = eval.getAnswer();
    }
    if((eval != evaluation) && (eval.isActive()) && (eval.getQuestion() != question) && (eval.getAnswer() == answer))
    {
       otherQuestion = eval.getQuestion();
    }
  }
  if(otherQuestion && otherAnswer)
  {
    unassignEvaluationOne = evaluation.workItem.getOrCreateEvaluation(question, otherAnswer);
    ;
    unassignEvaluationTwo = evaluation.workItem.getOrCreateEvaluation(otherQuestion, answer);
    ;
    assignEvaluation = evaluation.workItem.getOrCreateEvaluation(otherQuestion, otherAnswer);
    ;
    ;
    unassignEvaluationOne.setActive(false, 'system_off');
    unassignEvaluationTwo.setActive(false, 'system_off');
    assignEvaluation.setActive(true, 'system_off');
  }
  evaluation.setActive(true, 'system_set');
}
