/*
<DEPENDENCIES>
    <DEPENDS>Logger</DEPENDS>
</DEPENDENCIES>
*/
function DateSelectionWidget(sId)
{
	if (sId)
	{
		this.init(sId);
	}
}
DateSelectionWidget.prototype.init = function(sId)
{
	this.sId = sId;
}
DateSelectionWidget.prototype.getId = function()
{
	return this.sId;
}
DateSelectionWidget.prototype.setBroker = function(broker)
{
	this.broker = broker;
	broker.addChangeToDateHandle(new ObjectMethodAction(this, "changeToDate"));
	broker.addChangeFromDateHandle(new ObjectMethodAction(this, "changeFromDate"));
	broker.setManager(this);
}
DateSelectionWidget.prototype.setSelectionModel = function(model)
{
	this.model = model;
}
DateSelectionWidget.prototype.selectionModelChanged = function(model, changedItems)
{
	if (changedItems != null && changedItems != undefined)
		for (var i = 0; i < changedItems.length; i++)
		{
			var itemIndex = this.model.getIndexOf(changedItems[i]);
			if (itemIndex == 0)
			{
				this.broker.doFromDateChanged(changedItems[i].getValue());
			}
			else if (itemIndex == 1)
			{
				this.broker.doToDateChanged(changedItems[i].getValue());
			}
		}
}
DateSelectionWidget.prototype.start = function()
{
	this.selectionModelChanged(this.model, this.model.getActiveValues());
}
DateSelectionWidget.prototype.changeToDate = function(date)
{
	this.model.getToValue().changeValue(date);
}
DateSelectionWidget.prototype.changeFromDate = function(date)
{
	this.model.getFromValue().changeValue(date);
}
