/*
<DEPENDENCIES>
    <DEPENDS>Logger</DEPENDS>
</DEPENDENCIES>
*/
function SequenceItem(sId)
{
  if (sId) { this.init(sId); }
}
SequenceItem.prototype.init = function(sId)
{
  ;
  this.sId = sId;
  this.workItem = null; 
  this.sValue = null;
  this.sOrigin = ''; 
  this.bEvaluated = false;
  this.bUserContribution = false;
  this.bSystemConstructive = false;
  this.bSystemCorrective = false;
  this.aSCListener = new Array(); 
  this.nSCListener = 0;
}
SequenceItem.prototype.getId = function()
{
  return this.sId;
}
SequenceItem.prototype.start = function()
{
  ;
  this.sOrigin = ''; 
  this.bEvaluated = false;
  this.bUserContribution = false;
  this.bSystemConstructive = false;
  this.bSystemCorrective = false;
}
SequenceItem.prototype.toString = function()
{
  var s = '' +
          ' id=' + this.sId +
          ' evaled=' + (this.bEvaluated  ? '1' : '0') +
          ' usercon=' + (this.bUserContribution  ? '1' : '0') +
          ' syscons=' + (this.bSystemConstructive  ? '1' : '0') +
          ' syscorr=' + (this.bSystemCorrective  ? '1' : '0') +
          ' origin=' + (this.sOrigin ? this.sOrigin : 'null') +
          ' ';
  return s;
}
SequenceItem.prototype.setWorkItem = function(workItem)
{
  ;
  this.workItem = workItem;
}
SequenceItem.prototype.setValue = function(sValue)
{
  ;
  this.sValue = sValue;
}
SequenceItem.prototype.getValue = function()
{
  ;
  var value = this.sId;
  if ( this.sValue )
  {
    value = this.sValue;
  }
  return value;
}
SequenceItem.prototype.compare = function(oSequenceItem)
{
  ;
  var bMatch = false;
  if ( this.getValue() == oSequenceItem.getValue())
  {
    bMatch = true;
  }
  return bMatch;
}
SequenceItem.prototype.registerStatusChangeListener = function(scListener)
{
  ;
  if (this.aSCListener[scListener.getId()] != null)
  {
    ;
  }
  else
  {
    this.aSCListener[scListener.getId()] = scListener;
    this.nSCListener++;
    ;
    scListener.setModelItem(this);
  }
  return null;
}
SequenceItem.prototype.notify = function()
{
  ;
  if (this.workItem.getNotifyView())
  {
    for (var id in this.aSCListener)
    {
      this.aSCListener[id].changed(this);
    }
  }
}
SequenceItem.prototype.reset = function()
{
  ;
  this.sOrigin = ''; 
  this.bEvaluated = false;
  this.bUserContribution = false;
  this.bSystemConstructive = false;
  this.bSystemCorrective = false;
}
SequenceItem.prototype.changed = function(sOrigin)
{
  ;
  this.sOrigin = sOrigin ? sOrigin : 'user';
  switch (this.sOrigin)
  {
    case 'user':
      if(!this.workItem.bIsShowSolutionActive)
      {
        this.bTipp = false;
      }
      this.bUserContribution = true;
      break;
    case 'system_set':
    case 'system_approve':
      this.bTipp = true;
      this.bSystemConstructive = true;
      break;
    case 'system_solution':
      this.bSystemConstructive = true;
      break;
  }
  this.notify();
}
SequenceItem.prototype.getPositionOfSequenceItem = function(sequenceItem)
{
  ;
  return this.workItem.workingSequence.getPositionOfSequenceItem(sequenceItem);
}
SequenceItem.prototype.hasUserContribution = function()
{
  return this.bUserContribution;
}
SequenceItem.prototype.hasSystemContribution = function()
{
  return this.bSystemConstructive || this.bSystemCorrective;
}
SequenceItem.prototype.hasSystemConstuction = function()
{
  return this.bSystemConstructive;
}
SequenceItem.prototype.hasSystemCorrection = function()
{
  return this.bSystemCorrective;
}
SequenceItem.prototype.setSystemConstuction = function(bSysCon)
{
  this.bSystemConstructive = bSysCon;
}
SequenceItem.prototype.setSystemCorrection = function(bSysCor)
{
  this.bSystemCorrective = bSysCor;
}
SequenceItem.prototype.getOrigin = function()
{
  return this.sOrigin;
}
SequenceItem.prototype.isEvaluated = function()
{
  return this.bEvaluated;
}
SequenceItem.prototype.evaluate = function()
{
  ;
  this.bEvaluated = true;
  this.notify();
}
