/*
<DEPENDENCIES>
    <DEPENDS>Logger</DEPENDS>
    <DEPENDS>Globals</DEPENDS>
</DEPENDENCIES>
*/
function BasicSequenceTipStrategy(sId)
{
  if (sId) this.init(sId);
}
BasicSequenceTipStrategy.prototype.init = function(sId)
{
  ;
  this.sId = sId;
  this.workItem = null;
  this.bCanCycleTips = false; 
}
BasicSequenceTipStrategy.prototype.getId = function()
{
  return this.sId;
}
BasicSequenceTipStrategy.prototype.setWorkItem = function(workItem)
{
  ;
  this.workItem = workItem;
  this.nTips = 0; 
  this.bCycleTips = false;
}
BasicSequenceTipStrategy.prototype.start = function()
{
  ;
}
BasicSequenceTipStrategy.prototype.hasShowTip= function(bShow, bStepByStep, bSolutable, bCycleTips)
{
  ;
  var bHasTip = true;
  var aNewTippableSequenceItems = new Array();
  var aAlreadyTippedSequenceItems = new Array();
  var nIndexNew = 0;
  var nIndexAlready = 0;
  var sequenceItem = null;
  while ((sequenceItem = this.workItem.solutionSequence.getNextSequenceItem(sequenceItem)) != null)
  {
    if (this.sequenceItemHasTip(sequenceItem, bStepByStep))
    {
      if (sequenceItem.hasSystemContribution())
      {
        aAlreadyTippedSequenceItems[nIndexAlready++] = sequenceItem;
      }
      else
      {
        aNewTippableSequenceItems[nIndexNew++] = sequenceItem;
      }
    }
  }
  var aValidSequenceItems = null;
  var nIndex = 0;
  if (0)
  {
  }
  else if (nIndexAlready > 0)
  {
    aValidSequenceItems = aAlreadyTippedSequenceItems;
    nIndex = nIndexAlready;
    ;
  }
  else if (nIndexNew > 0)
  {
    if (bSolutable)
    {
      aValidSequenceItems = aNewTippableSequenceItems;
      nIndex = nIndexNew;
    }
    else
    {
      aValidSequenceItems = aNewTippableSequenceItems;
      nIndex = nIndexNew;
      var nMatching = this.workItem.activeSequence.countMatchingSequenceItems(this.workItem.solutionSequence);
      var nCount = this.workItem.solutionSequence.countSequenceItems();
      ;
      if (nMatching >= this.workItem.solutionSequence.countSequenceItems()-2)
      {
        nIndex = 0;
      }
    }
    if (nIndex > 0)
    {
      ;
    }
  }
  if (nIndex <= 0)
  {
    bHasTip = false;
    ;
  }
  else
  {
    ;
  }
  if (bShow && bHasTip)
  {
    var nRandomIndex = 0;
    var nLow = 0;
    var nHigh = nIndex - 1;
    nRandomIndex = nLow; 
    var item = aValidSequenceItems[nRandomIndex];
    this.sequenceItemShowTip(item, bStepByStep);
    this.nTips++;
  }
  return bHasTip;
}
BasicSequenceTipStrategy.prototype.sequenceItemHasTip = function(sequenceItem, bStepByStep)
{
  ;
  var bHasTip = false;
  var activeSequence = this.workItem.activeSequence;
  var solutionSequence = this.workItem.solutionSequence;
  var nIsPos = activeSequence.getPositionOfSequenceItem(sequenceItem);
  ;
  if(sequenceItem.compare(solutionSequence.getSequenceItemAtPosition(nIsPos)))
  {
    bHasTip = true;
    ;
  }
  return bHasTip;
}
BasicSequenceTipStrategy.prototype.sequenceItemShowTip = function(sequenceItem, bStepByStep)
{
  ;
  var solutionSequence = this.workItem.solutionSequence;
  this.workItem.moveSequenceItemAtPosition(sequenceItem, solutionSequence.getPositionOfSequenceItem(sequenceItem), 'system_approve')
}
MoveWrongSequenceTipStrategy.prototype             = new BasicSequenceTipStrategy();
MoveWrongSequenceTipStrategy.prototype.constructor = MoveWrongSequenceTipStrategy;
MoveWrongSequenceTipStrategy.superclass            = BasicSequenceTipStrategy.prototype;
function MoveWrongSequenceTipStrategy(sId)
{
  if (sId) this.init(sId);
}
MoveWrongSequenceTipStrategy.prototype.sequenceItemHasTip = function(sequenceItem, bStepByStep)
{
  ;
  var activeSequence = this.workItem.activeSequence;
  var solutionSequence = this.workItem.solutionSequence;
  var bHasTip = true;
  var nShouldPos = -1;
  var nIsPos = -1;
  if ( ! activeSequence)
  {
    bHasTip = false;
  }
  if (bHasTip)
  {
    if (activeSequence.isCorrect())
    {
      bHasTip = false;
    }
  }
  if (bHasTip)
  {
    nIsPos = activeSequence.getPositionOfSequenceItem(sequenceItem);
    if (nIsPos == -1)
    {
      bHasTip = false;
    }
  }
  if (bHasTip)
  {
    if(sequenceItem.compare(solutionSequence.getSequenceItemAtPosition(nIsPos)))
    {
      bHasTip = false;
    }
  }
  return bHasTip;
}
MoveWrongSequenceTipStrategy.prototype.sequenceItemShowTip = function(sequenceItem, bStepByStep)
{
  ;
  var i = null;
  var solutionSequence = this.workItem.solutionSequence;
  var activeSequence = this.workItem.activeSequence;
  var nShouldPosition = solutionSequence.getPositionOfSequenceItem(sequenceItem);
  var oCurrentSequenceItemAtSnapPoint = activeSequence.getSequenceItemAtPosition(nShouldPosition);
  while ( i != 50 )
  {
    i++;
    if( ! sequenceItem.compare(oCurrentSequenceItemAtSnapPoint) )
    {
      break;
    }
    nShouldPosition = solutionSequence.getPositionOfSequenceItem(oCurrentSequenceItemAtSnapPoint);
    oCurrentSequenceItemAtSnapPoint = activeSequence.getSequenceItemAtPosition(nShouldPosition)
  }
  if ( i == 50 )
  {
    ;
  }
  this.workItem.moveSequenceItemAtPosition(sequenceItem, nShouldPosition, 'system_set')
}
