/*
<DEPENDENCIES>
    <DEPENDS>Logger</DEPENDS>
    <DEPENDS>Actions</DEPENDS>
    <DEPENDS>Broker</DEPENDS>
</DEPENDENCIES>
*/
function TipHandlerAdapter(sId)
{
  this.init(sId)
}
TipHandlerAdapter.prototype.init = function(sId)
{
  this.sId = sId;
  this.broker = new Broker(sId + "_broker");
  this.tipManager = null;
  this.tipEnabled = true;
}
TipHandlerAdapter.prototype.addTipHandler = function(tipAction)
{
  this.broker.registerAction("tip", tipAction);
}
TipHandlerAdapter.prototype.setTipManager = function(tipManager)
{
  this.tipManager = tipManager;
}
TipHandlerAdapter.prototype.showTip = function()
{
  if(this.tipEnabled)
  {
    this.broker.getMessage("tip");
    return true;
  }
  return false;
}
TipHandlerAdapter.prototype.hasTip = function()
{
  return this.tipEnabled;
}
TipHandlerAdapter.prototype.showSolution = function()
{
}
TipHandlerAdapter.prototype.hideSolution = function()
{
}
TipHandlerAdapter.prototype.tipAvailable = function()
{
  this.tipEnabled = true;
}
TipHandlerAdapter.prototype.tipUnavailable = function()
{
  this.tipEnabled = false;
}
TipHandlerAdapter.prototype.getSetTipAvailableAction = function()
{
  return new ObjectMethodAction(this, 'tipAvailable');
}
TipHandlerAdapter.prototype.getSetTipUnavailableAction = function()
{
  return new ObjectMethodAction(this, 'tipUnavailable');
}
TipHandlerAdapter.prototype.reset = function()
{
  this.tipEnabled = true;
}
TipHandlerAdapter.prototype.getResetAction = function()
{
  return new ObjectMethodAction(this, "reset");
}
TipHandlerAdapter.prototype.getId = function()
{
  return this.sId;
}
